package com.xx.hbhconsumer.adapter;

import android.content.Context;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.HotSalesBean;
import com.xx.hbhconsumer.databinding.ItemHotSalesGoodsBinding;
import com.xx.hbhconsumer.utils.RetrofitClient;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import me.goldze.mvvmhabit.utils.StringUtils;


public class HotSalesGoodsAdapter extends xxBaseRecyclerViewAdapter<ItemHotSalesGoodsBinding, HotSalesBean> {

    public HotSalesGoodsAdapter(Context context) {
        super(context);
        mContext = context;
    }

    @Override
    public int initLayout() {
        return R.layout.item_hot_sales_goods;
    }

    @Override
    protected void covert(ItemHotSalesGoodsBinding dataBind, HotSalesBean data, int position) {
        //   将接口调出来的布局遍历上去
        dataBind.setHotSalesBean(data);

        Glide.with(mContext).load(RetrofitClient.baseImgUrl + data.getFilePath())
                .into(dataBind.ivGoodsImg);

        dataBind.tvGoodsName.setText(data.getCommodityName());
        dataBind.tvShopName.setText(data.getStoreName());

        String price = data.getCommodityPrice();
        if (!StringUtils.isEmpty(price) && price.contains("\\.")) {
            dataBind.tvPriceInteger.setText(price.split("\\.")[0]);
            dataBind.tvPriceDecimal.setText("." + price.split("\\.")[1]);
        }
    }
}
