package com.xx.hbhconsumer.adapter;

import android.content.Context;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.LowPriceGoodsBean;
import com.xx.hbhconsumer.data.http.respons.OrderBean;
import com.xx.hbhconsumer.databinding.ItemLowPricedGoodsBinding;
import com.xx.hbhconsumer.databinding.ItemOrderGoodsBinding;
import com.xx.hbhconsumer.utils.RetrofitClient;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import me.goldze.mvvmhabit.utils.StringUtils;


public class LowPricedGoodsAdapter extends xxBaseRecyclerViewAdapter<ItemLowPricedGoodsBinding, LowPriceGoodsBean> {

    public LowPricedGoodsAdapter(Context context) {
        super(context);
        mContext = context;
    }

    @Override
    public int initLayout() {
        return R.layout.item_low_priced_goods;
    }

    @Override
    protected void covert(ItemLowPricedGoodsBinding dataBind, LowPriceGoodsBean data, int position) {
        //   将接口调出来的布局遍历上去
        dataBind.setLowPriceGoodsBean(data);

        Glide.with(mContext).load(RetrofitClient.baseImgUrl + data.getFilePath())
                .into(dataBind.ivGoodsImg);

        String price = data.getCommodityPrice();
        if (!StringUtils.isEmpty(price) && price.contains("\\.")) {
            dataBind.tvPriceInteger.setText(price.split("\\.")[0]);
            dataBind.tvPriceDecimal.setText("." + price.split("\\.")[1]);
        }
    }
}
