package com.xx.hbhconsumer.adapter;

import android.content.Context;
import android.view.View;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.OrderBean;
import com.xx.hbhconsumer.databinding.ItemOrderBinding;
import com.xx.hbhconsumer.ui.order.ReceiveCouponDialog;
import com.xx.hbhconsumer.utils.RetrofitClient;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import me.goldze.mvvmhabit.utils.StringUtils;


public class OrderAdapter extends xxBaseRecyclerViewAdapter<ItemOrderBinding, OrderBean> {

    public OrderAdapter(Context context) {
        super(context);
        mContext = context;
    }

    @Override
    public int initLayout() {
        return R.layout.item_order;
    }

    @Override
    protected void covert(ItemOrderBinding dataBind, OrderBean data, int position) {

        Glide.with(mContext).load(RetrofitClient.baseImgUrl + data.getCommodityList().get(0).getCommodityPictureList().get(0))
                .into(dataBind.ivGoodsImg);

        Glide.with(mContext).load(RetrofitClient.baseImgUrl + data.getMerchant().getCompanyLogoFile().getUrl())
                .into(dataBind.ivShopLogo);


        //   将接口调出来的布局遍历上去
        dataBind.setOrderBean(data);
        if ("2".equals(data.getOrderStatus())) {
            dataBind.tvCancelOrder.setVisibility(View.GONE);
            dataBind.tvPay.setVisibility(View.GONE);
            dataBind.tvReceiveCoupon.setVisibility(View.VISIBLE);
            dataBind.tvOrderState.setText("已完成");
        } else if ("1".equals(data.getOrderStatus())) {
            dataBind.tvCancelOrder.setVisibility(View.VISIBLE);
            dataBind.tvPay.setVisibility(View.VISIBLE);
            dataBind.tvReceiveCoupon.setVisibility(View.GONE);
            dataBind.tvOrderState.setText("待付款");
        } else if ("3".equals(data.getOrderStatus())) {
            dataBind.tvCancelOrder.setVisibility(View.GONE);
            dataBind.tvPay.setVisibility(View.GONE);
            dataBind.tvReceiveCoupon.setVisibility(View.GONE);
            dataBind.tvOrderState.setText("已关闭");
        }

        dataBind.tvShopName.setText(data.getMerchant().getStoreName());
        dataBind.tvGoodsNum.setText("x" + data.getQuantity());
        dataBind.tvGoodsName.setText(data.getCommodityList().get(0).getCommodityName());

        String price = data.getCommodityList().get(0).getPrice();
        if (!StringUtils.isEmpty(price) && price.contains("\\.")) {
            dataBind.tvPriceInteger.setText(price.split("\\.")[0]);
            dataBind.tvPriceDecimal.setText("." + price.split("\\.")[1]);
        }
        String actualPayment = String.valueOf(data.getActualPayment());
        if (!StringUtils.isEmpty(actualPayment) && actualPayment.contains("\\.")) {
            dataBind.tvPriceInteger.setText(actualPayment.split("\\.")[0]);
            dataBind.tvPriceDecimal.setText("." + actualPayment.split("\\.")[1]);
        }

        dataBind.tvReceiveCoupon.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ReceiveCouponDialog dialog = new ReceiveCouponDialog(mContext, 1);
                dialog.show();
            }
        });
    }
}
