package com.xx.hbhconsumer.adapter;

import android.content.Context;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.Commodity;
import com.xx.hbhconsumer.data.http.respons.OrderBean;
import com.xx.hbhconsumer.databinding.ItemCreditGoodsBinding;
import com.xx.hbhconsumer.databinding.ItemOrderBinding;
import com.xx.hbhconsumer.databinding.ItemOrderGoodsBinding;
import com.xx.hbhconsumer.utils.RetrofitClient;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import me.goldze.mvvmhabit.utils.StringUtils;


public class OrderGoodsAdapter extends xxBaseRecyclerViewAdapter<ItemOrderGoodsBinding, Commodity> {

    public OrderGoodsAdapter(Context context) {
        super(context);
        mContext = context;
    }

    @Override
    public int initLayout() {
        return R.layout.item_order_goods;
    }

    @Override
    protected void covert(ItemOrderGoodsBinding dataBind, Commodity data, int position) {
        //   将接口调出来的布局遍历上去
        dataBind.setCommodity(data);

        if (data.getCommodityPictureList() != null && !data.getCommodityPictureList().isEmpty()) {
            Glide.with(mContext)
                    .load(RetrofitClient.baseImgUrl + data.getCommodityPictureList().get(0).getFilePath())
                    .into(dataBind.ivGoodsImg);
        }
        dataBind.tvGoodsName.setText(data.getCommodityName());
        String price = data.getPrice();
        if (!StringUtils.isEmpty(price) && price.contains("\\.")) {
            dataBind.tvPriceInteger.setText(price.split("\\.")[0]);
            dataBind.tvPriceDecimal.setText("." + price.split("\\.")[1]);
        }
        dataBind.tvNum.setText("x" + data.getCommodityQuantity());
    }
}
