package com.xx.hbhconsumer.adapter;

import android.content.Context;

import androidx.recyclerview.widget.LinearLayoutManager;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.OrderBean;
import com.xx.hbhconsumer.data.http.respons.SearchShopBean;
import com.xx.hbhconsumer.data.http.respons.ShopAndGoodsBean;
import com.xx.hbhconsumer.databinding.ItemOrderBinding;
import com.xx.hbhconsumer.databinding.ItemSearchShopBinding;
import com.xx.hbhconsumer.utils.RetrofitClient;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import java.util.ArrayList;
import java.util.List;


public class SearchShopAdapter extends xxBaseRecyclerViewAdapter<ItemSearchShopBinding, SearchShopBean> {

    public SearchShopAdapter(Context context) {
        super(context);
        mContext = context;
    }

    @Override
    public int initLayout() {
        return R.layout.item_search_shop;
    }

    @Override
    protected void covert(ItemSearchShopBinding dataBind, SearchShopBean data, int position) {
        //   将接口调出来的布局遍历上去
        dataBind.setSearchShopBean(data);
        if (data.getLogoFile() != null) {
            Glide.with(mContext)
                    .load(RetrofitClient.baseImgUrl + data.getLogoFile().getFilePath())
                    .into(dataBind.ivShopLogo);
        }

        dataBind.rvGoodsList.setNestedScrollingEnabled(false);

        //获取适配器上下文
        SearchShopGoodsAdapter orderListAdapter = new SearchShopGoodsAdapter(mContext);
        LinearLayoutManager layoutManager = new LinearLayoutManager(mContext);
        layoutManager.setOrientation(LinearLayoutManager.HORIZONTAL);
        dataBind.rvGoodsList.setLayoutManager(layoutManager);
        //把adapterset进去
        dataBind.rvGoodsList.setAdapter(orderListAdapter);
        orderListAdapter.mList = data.getCommodityList();

    }
}
