package com.xx.hbhconsumer.adapter;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;

import androidx.recyclerview.widget.GridLayoutManager;

import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.CategoryBean;
import com.xx.hbhconsumer.databinding.ItemSecondCategoryBinding;
import com.xx.hbhconsumer.ui.shop.ShopSearchActivity;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

public class SecondCategoryAdapter extends xxBaseRecyclerViewAdapter<ItemSecondCategoryBinding, CategoryBean> {

    public SecondCategoryAdapter(Context context) {
        super(context);
        mContext = context;
    }

    @Override
    public int initLayout() {
        return R.layout.item_second_category;
    }

    @Override
    protected void covert(ItemSecondCategoryBinding dataBind, CategoryBean data, int position) {
        //   将接口调出来的布局遍历上去
        dataBind.setCategoryBean(data);
        //获取适配器上下文
        GridLayoutManager manager = new GridLayoutManager(mContext,2);
        dataBind.rlThirdCategoryList.setLayoutManager(manager);

        //获取适配器上下文
        ThirdCategoryAdapter thirdCategoryAdapter = new ThirdCategoryAdapter(mContext);

        //把adapterset进去
        dataBind.rlThirdCategoryList.setAdapter(thirdCategoryAdapter);
        thirdCategoryAdapter.mList = data.getChildren();
        thirdCategoryAdapter.setOnItemClick((position1, data1) -> {
            Intent intent = new Intent(mContext, ShopSearchActivity.class);
            Bundle bundle = new Bundle();
            bundle.putString("categoryId", data1.getCategoryId());
            mContext.startActivity(intent, bundle);
        });
    }
}
