package com.xx.hbhconsumer.adapter;

import android.content.Context;

import androidx.recyclerview.widget.LinearLayoutManager;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.OrderBean;
import com.xx.hbhconsumer.data.http.respons.ShopAndGoodsBean;
import com.xx.hbhconsumer.data.http.respons.ShopBean;
import com.xx.hbhconsumer.databinding.ItemShopBinding;
import com.xx.hbhconsumer.utils.RetrofitClient;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import java.util.ArrayList;
import java.util.List;

public class ShopAdapter extends xxBaseRecyclerViewAdapter<ItemShopBinding, ShopAndGoodsBean> {
    public ShopAdapter(Context context) {
        super(context);
        mContext = context;
    }

    @Override
    public int initLayout() {
        return R.layout.item_shop;
    }

    @Override
    protected void covert(ItemShopBinding dataBind, ShopAndGoodsBean data, int position) {
        //   将接口调出来的布局遍历上去
        dataBind.setShopAndGoodsBean(data);
        if (data.getStoreLogo() != null) {
            Glide.with(mContext)
                    .load(RetrofitClient.baseImgUrl + data.getStoreLogo())
                    .into(dataBind.ivShopLogo);
        }
        //获取适配器上下文
        ShopGoodsAdapter orderListAdapter = new ShopGoodsAdapter(mContext);
        LinearLayoutManager layoutManager = new LinearLayoutManager(mContext);
        layoutManager.setOrientation(LinearLayoutManager.HORIZONTAL);
        dataBind.rvGoods.setLayoutManager(layoutManager);
        //把adapterset进去
        dataBind.rvGoods.setAdapter(orderListAdapter);
        orderListAdapter.mList = data.getCommodityList();
    }


}
