package com.xx.hbhconsumer.data.http

import com.xx.hbhconsumer.data.http.respons.ActivityCouponBean
import com.xx.hbhconsumer.data.http.respons.AdvertisingBean
import com.xx.hbhconsumer.data.http.respons.AppInformationBean
import com.xx.hbhconsumer.data.http.respons.BoothBean
import com.xx.hbhconsumer.data.http.respons.CategoryBean
import com.xx.hbhconsumer.data.http.respons.ClaimedCoupon
import com.xx.hbhconsumer.data.http.respons.CollectionBean
import com.xx.hbhconsumer.data.http.respons.CreditDetailBean
import com.xx.hbhconsumer.data.http.respons.CreditGoodsBean
import com.xx.hbhconsumer.data.http.respons.CreditGoodsDetailBean
import com.xx.hbhconsumer.data.http.respons.CreditOrderBean
import com.xx.hbhconsumer.data.http.respons.CreditRecordBean
import com.xx.hbhconsumer.data.http.respons.Filebean
import com.xx.hbhconsumer.data.http.respons.GuessLikeGoodsBean
import com.xx.hbhconsumer.data.http.respons.HotSalesBean
import com.xx.hbhconsumer.data.http.respons.LowPriceGoodsBean
import com.xx.hbhconsumer.data.http.respons.MemberInfoBean
import com.xx.hbhconsumer.data.http.respons.MerchantBean
import com.xx.hbhconsumer.data.http.respons.MessageBean
import com.xx.hbhconsumer.data.http.respons.MyCouponBean
import com.xx.hbhconsumer.data.http.respons.NewCommodityBean
import com.xx.hbhconsumer.data.http.respons.OrderBean
import com.xx.hbhconsumer.data.http.respons.RecruitBean
import com.xx.hbhconsumer.data.http.respons.RegisterBean
import com.xx.hbhconsumer.data.http.respons.SearchGoodsBean
import com.xx.hbhconsumer.data.http.respons.SearchShopBean
import com.xx.hbhconsumer.data.http.respons.ShopAndGoodsBean
import com.xx.hbhconsumer.data.http.respons.ShopBean
import com.xx.hbhconsumer.data.http.respons.ShopGoodsBean
import com.xx.hbhconsumer.data.http.respons.UserInfoBean
import io.reactivex.rxjava3.core.Observable
import me.goldze.mvvmhabit.http.BasePageResponse
import me.goldze.mvvmhabit.http.BaseResponse
import okhttp3.MultipartBody
import okhttp3.RequestBody
import retrofit2.http.Body
import retrofit2.http.GET
import retrofit2.http.Headers
import retrofit2.http.Multipart
import retrofit2.http.POST
import retrofit2.http.PUT
import retrofit2.http.Part
import retrofit2.http.Path
import retrofit2.http.Query


interface ApiService {

    /**
     * 登陆
     */
    @Headers("Content-type:application/json")
    @POST("app/user/login")
    open fun Login(@Body requestBody: RequestBody): Observable<BaseResponse<String>>
    /**
     * 修改密码
     */
    @Headers("Content-type:application/json")
    @POST("app/user/update-password")
    open fun ChangePwd(@Body requestBody: RequestBody): Observable<BaseResponse<String>>
    /**
     * 忘记密码
     */
    @Headers("Content-type:application/json")
    @POST("app/user/forget-password")
    open fun ForegetPwd(@Body requestBody: RequestBody): Observable<BaseResponse<String>>

    /**
     * 获取验证码
     */
    @Headers("Content-type:application/json")
    @GET("app/user/send-verification-code")
    open fun getCode(@Query("phone") phone: String): Observable<BaseResponse<String>>

    /**
     * 注册
     */
    @Headers("Content-type:application/json")
    @POST("app/user/register")
    open fun register(@Body requestBody: RequestBody): Observable<BaseResponse<RegisterBean>>


    /**
     * 获取用户信息
     */
    @Headers("Content-type:application/json")
    @GET("app/getInfo")
    open fun getUserInfo(): Observable<BaseResponse<UserInfoBean>>


    /**
     * 获取展位管理列表
     * status:状态 0启用 1停用
     * affiliatedCompany:所属公司
     */
    @Headers("Content-type:application/json")
    @GET("app/booth/list-all")
    open fun getBoothList(
        @Query("status") status: String,
        @Query("affiliatedCompany") affiliatedCompany: String
    ): Observable<BaseResponse<List<BoothBean>>>

    /**
     * 上传
     */
    @Multipart
    @Headers("clientType:fy_authority")
    @POST("common/upload")
    fun upLoadFile(@Part file: MultipartBody.Part): Observable<BaseResponse<Filebean>>

    /**
     * 上传
     */
    @Multipart
    @Headers("clientType:fy_authority")
    @POST("common/uploads")
    fun upLoadFiles(@Part file: List<MultipartBody.Part>): Observable<BaseResponse<List<Filebean>>>

    /**
     * APP广告位查询
     */
    @Headers("Content-type:application/json")
    @GET("app/message/getMessageList")
    fun getMessageList(@Query("flag") flag: Int): Observable<BaseResponse<List<MessageBean>>>

    /**
     * APP广告位查询
     */
    @Headers("Content-type:application/json")
    @POST("app/adList/list")
    fun postADList(@Body requestBody: RequestBody): Observable<BaseResponse<List<AdvertisingBean>>>

    /**
     * APP广告位查询
     */
    @Headers("Content-type:application/json")
    @GET("app/recommend/lowPrice/{affiliatedCompany}")
    fun lowPriceList(@Path(value="affiliatedCompany") affiliatedCompany: String): Observable<BaseResponse<List<LowPriceGoodsBean>>>

    /**
     * APP广告位查询
     */
    @Headers("Content-type:application/json")
    @GET("app/recommend/like/{affiliatedCompany}")
    fun guessLikeGood(@Path(value="affiliatedCompany") affiliatedCompany: String): Observable<BaseResponse<List<GuessLikeGoodsBean>>>

    /**
     * 获取商户管理详细信息
     */
    @Headers("Content-type:application/json")
    @GET("app/storeRecommend/storeTop/{affiliatedCompany}")
    fun getTopShop(@Path("affiliatedCompany") affiliatedCompany:String?): Observable<BaseResponse<ShopBean>>

    /**
     * 获取商户管理详细信息
     */
    @Headers("Content-type:application/json")
    @GET("app/commodity/category-tree")
    fun getCategoryTree(): Observable<BaseResponse<List<CategoryBean>>>

    /**
     * 获取商户管理详细信息
     */
    @Headers("Content-type:application/json")
    @GET("app/storeRecommend/story/{affiliatedCompany}")
    fun getTopShopList(@Path("affiliatedCompany") affiliatedCompany:String?): Observable<BaseResponse<List<ShopBean>>>

    @Headers("Content-type:application/json")
    @GET("app/storeRecommend/winnow/{affiliatedCompany}")
    fun getShopList(@Path("affiliatedCompany") affiliatedCompany:String?): Observable<BaseResponse<List<ShopAndGoodsBean>>>


    @Headers("Content-type:application/json")
    @POST("/app/commodity/consumer-app/merchant-commodity")
    fun getShopGoodsList(@Body requestBody: RequestBody): Observable<BasePageResponse<ShopGoodsBean>>

    @Headers("Content-type:application/json")
    @GET("app/commodity/consumer-app/list-by-category")
    fun listShopGoodsByCategory(@Body requestBody: RequestBody): Observable<BaseResponse<List<ShopAndGoodsBean>>>

    @Headers("Content-type:application/json")
    @POST("app/commodity/consumer-app/list")
    fun searchGoods(@Body requestBody: RequestBody): Observable<BasePageResponse<SearchGoodsBean>>

    @Headers("Content-type:application/json")
    @GET("app/merchant/get-merchant-of-consumer-app")
    fun searchShop(@Query("searchWord") searchWord:String?): Observable<BasePageResponse<SearchShopBean>>

    /**
     * 获取商户管理详细信息
     */
    @Headers("Content-type:application/json")
    @GET("app/merchant/{businessId}")
    fun getMerchantById(@Path("businessId") id:String?): Observable<BaseResponse<MerchantBean>>


    /**
     * 获取三级分类
     */
    @Headers("Content-type:application/json")
    @POST("app/commodity/category-tree")
    fun postCategory(@Body requestBody: RequestBody): Observable<BaseResponse<List<CategoryBean>>>


    /**
     * 新增商品
     */
    @Headers("Content-type:application/json")
    @POST("app/commodity/merchant-app/add")
    fun postAddProduct(@Body requestBody: RequestBody): Observable<BaseResponse<Boolean>>

    @Headers("Content-type:application/json")
    @GET("app/MemberCollection/list")
    fun memberCollectionList(@Query("memberId") memberId: String): Observable<BaseResponse<List<CollectionBean>>>

    @Headers("Content-type:application/json")
    @GET("app/myHome/list")
    fun memberInfo(): Observable<BaseResponse<MemberInfoBean>>
    @Headers("Content-type:application/json")
    @GET("app/message/getMessageList")
    fun getMessageList(): Observable<BaseResponse<MemberInfoBean>>

    @Headers("Content-type:application/json")
    @GET("app/memberSign/{companyId}")
    fun memberSign(@Path("companyId") companyId: String):  Observable<BaseResponse<Boolean>>

    @Headers("Content-type:application/json")
    @GET("app/recommend/newCommodity/{affiliatedCompany}")
    fun newCommodity(@Path("affiliatedCompany") affiliatedCompany: String):  Observable<BasePageResponse<NewCommodityBean>>

    @Headers("Content-type:application/json")
    @GET("app/recommend/sale/{affiliatedCompany}")
    fun hotSales(@Path("affiliatedCompany") affiliatedCompany: String):  Observable<BasePageResponse<HotSalesBean>>

    @Headers("Content-type:application/json")
    @GET("app/order/consumer-app/list")
    fun getOrderList(@Query("orderStatus") orderStatus: String):  Observable<BasePageResponse<OrderBean>>

    @Headers("Content-type:application/json")
    @GET("app/order/consumer-app/order-info/{businessId}")
    fun getOrderDetail(@Path("businessId") businessId: String):  Observable<BaseResponse<OrderBean>>

    @Headers("Content-type:application/json")
    @PUT("app/order/consumer-app/close/{businessId}")
    fun closeOrder(@Path("businessId") businessId: String):  Observable<BaseResponse<Boolean>>


    @Headers("Content-type:application/json")
    @POST("app/order/consumer-app/claimed-coupon")
    fun getClaimedCoupon(@Query("orderId") orderId: String):  Observable<BaseResponse<ClaimedCoupon>>


    @Headers("Content-type:application/json")
    @GET("app/myCoupon/listUse")
    fun getUsedCouponList():  Observable<BasePageResponse<MyCouponBean>>

    @Headers("Content-type:application/json")
    @GET("app/myCoupon/listUnUse")
    fun getUnUsedCouponList():  Observable<BasePageResponse<MyCouponBean>>

    @Headers("Content-type:application/json")
    @GET("app/pointExchange/list")
    fun getCreditOrderList(@Query("status") status: String):  Observable<BasePageResponse<CreditOrderBean>>

    @Headers("Content-type:application/json")
    @GET("/app/pointExchange/{businessId}")
    fun getCreditOrderDetail(@Path("businessId") businessId: String):  Observable<BaseResponse<CreditOrderBean>>


    @Headers("Content-type:application/json")
    @GET("app/getCoupon/getCouponAppList")
    fun getCouponAppList():  Observable<BasePageResponse<ActivityCouponBean>>

    @Headers("Content-type:application/json")
    @GET("/app/getCoupon/{businessId}")
    fun getCoupon(@Path("businessId") businessId: String):  Observable<BaseResponse<Int>>

    @Headers("Content-type:application/json")
    @GET("app/myPoint/pointCommodity/list")
    fun getCreditGoodsList():  Observable<BasePageResponse<CreditGoodsBean>>

    @Headers("Content-type:application/json")
    @POST("app/myPoint/IntegralScheduleList")
    fun getCreditRecordList(@Body requestBody: RequestBody):  Observable<BasePageResponse<CreditRecordBean>>

    @Headers("Content-type:application/json")
    @GET("app/myPoint/getMyPoint")
    fun getMyPoint():  Observable<BaseResponse<CreditDetailBean>>

    @Headers("Content-type:application/json")
    @GET("app/pointExchange/pointCommodity/list")
    fun getAllCreditGoodsList():  Observable<BasePageResponse<CreditGoodsBean>>

    @Headers("Content-type:application/json")
    @GET("app/pointExchange/pointCommodity/listTop")
    fun getTopCreditGoodsList():  Observable<BasePageResponse<CreditGoodsBean>>

    @Headers("Content-type:application/json")
    @GET("app/pointExchange/getIntegralCommodity/{businessId}")
    fun getCreditGoodsDetail(@Path("businessId") businessId: String):  Observable<BaseResponse<CreditGoodsDetailBean>>


    @Headers("Content-type:application/json")
    @POST("app/pointExchange/addPointOrder")
    fun creditExchange(@Body requestBody: RequestBody):  Observable<BaseResponse<Int>>

    @Headers("Content-type:application/json")
    @POST("app/recruitment/queryAppRecruitmentList")
    fun queryAppRecruitmentList(@Body requestBody: RequestBody):  Observable<BasePageResponse<RecruitBean>>
    @Headers("Content-type:application/json")
    @GET("app/recruitment/{businessId}")
    fun queryAppRecruitmentDetail(@Path("businessId") businessId: String):  Observable<BaseResponse<RecruitBean>>

    @Headers("Content-type:application/json")
    @POST("app/recruitment/add")
    fun recruitment(@Body requestBody: RequestBody):  Observable<BaseResponse<Integer>>


    @Headers("Content-type:application/json")
    @POST("app/information/queryAppInformationList")
    fun queryAppInformationList(@Body requestBody: RequestBody):  Observable<BaseResponse<List<AppInformationBean>>>


}