package com.xx.hbhconsumer.data.http

import com.xx.hbhconsumer.data.http.respons.Filebean
import com.xx.hbhconsumer.utils.RetrofitClient
import io.reactivex.rxjava3.core.Observable
import me.goldze.mvvmhabit.base.BaseModel
import me.goldze.mvvmhabit.http.BaseResponse
import okhttp3.MediaType
import okhttp3.MultipartBody
import okhttp3.RequestBody
import java.io.File

open class BaseRespons : BaseModel() {

    var apiService: ApiService

    init {
        apiService = RetrofitClient.getInstance().create(ApiService::class.java)
    }

    fun upLoadFile(file: File): Observable<BaseResponse<Filebean>> {
        val builder = MultipartBody.Builder()
            .setType(MultipartBody.FORM) //在这里添加服务器除了文件之外的其他参数

        val requestBody = RequestBody.create(MediaType.parse("multipart/form-data"), file)
        builder.addFormDataPart("files", file.name, requestBody)
        val parts = builder.build().part(0)
        return apiService.upLoadFile(parts)
    }

    /**
     * 文件多个上传
     */
    fun upLoadFiles(files: List<File>): Observable<BaseResponse<List<Filebean>>> {
        val builder = MultipartBody.Builder()
            .setType(MultipartBody.FORM) //在这里添加服务器除了文件之外的其他参数
//            .addFormDataPart("type", "0").addFormDataPart("dir", "")
        for (fl in files) {
            val requestBody = RequestBody.create(MediaType.parse("multipart/form-data"), fl)
            builder.addFormDataPart("files", fl.name, requestBody)
        }

        val parts = builder.build().parts()

        return apiService.upLoadFiles(parts)
    }

}