package com.xx.hbhconsumer.data.http.requst;

import com.xx.hbhconsumer.data.http.BaseRespons;
import com.xx.hbhconsumer.data.http.respons.AdvertisingBean;
import com.xx.hbhconsumer.data.http.respons.GuessLikeGoodsBean;
import com.xx.hbhconsumer.data.http.respons.LowPriceGoodsBean;
import com.xx.hbhconsumer.data.http.respons.MessageBean;

import java.util.List;

import io.reactivex.rxjava3.core.Observable;
import me.goldze.mvvmhabit.http.ApiParams;
import me.goldze.mvvmhabit.http.BaseResponse;
import okhttp3.RequestBody;

public class HomeRequest extends BaseRespons {


    /**
     * 活动列表
     */
//    public Observable<BaseResponse<List<ActivityCenterBean>>> getActivityList() {
//
//        ApiParams<HuanBoHaiRequestBody> apiParams = new ApiParams<HuanBoHaiRequestBody>();
//        HuanBoHaiRequestBody requestBody = new HuanBoHaiRequestBody("1", "3");
//        RequestBody body=apiParams.setParams(requestBody);
//        return getApiService().getActivityList(body);
//    }

    /**
     * 获取广告列表
     * @return
     */
    public Observable<BaseResponse<List<MessageBean>>> getMessageList() {
        return getApiService().getMessageList(0);
    }

    /**
     * 获取广告列表
     * @return
     */
    public Observable<BaseResponse<List<AdvertisingBean>>> getAdList() {

        ApiParams<AdvertisingRequestBody> apiParams = new ApiParams<AdvertisingRequestBody>();
        AdvertisingRequestBody requestBody = new AdvertisingRequestBody("1","1");
        RequestBody body=apiParams.setParams(requestBody);
        return getApiService().postADList(body);
    }


    /**
     * 低价好物商品列表
     */
    public Observable<BaseResponse<List<LowPriceGoodsBean>>> getLowPriceList(String affiliatedCompany) {
        return getApiService().lowPriceList(affiliatedCompany);
    }

    /**
     * 低价好物商品列表
     */
    public Observable<BaseResponse<List<GuessLikeGoodsBean>>> getGuessLikeGood(String affiliatedCompany) {
        return getApiService().guessLikeGood(affiliatedCompany);
    }

    /**
     * 低价好物商品列表
     */
    public Observable<BaseResponse<Boolean>> memberSign(String companyId) {
        return getApiService().memberSign(companyId);
    }


    /**
     * 获取广告列表
     * affiliatedCompany  string 所属公司 1- 河西 2-滨海
     * rotographDisplay string  1-消费者app 2-商户app 3-企业app
     */
    public class AdvertisingRequestBody {
        public String affiliatedCompany;
        public String rotographDisplay;

        public AdvertisingRequestBody(String affiliatedCompany,String rotographDisplay) {
            this.affiliatedCompany = affiliatedCompany;
            this.rotographDisplay = rotographDisplay;
        }
    }

    /**
     * "activityShop": 传店铺类型 1-河西 2-滨海
     * "isPublish": 传APP类型 1-消费者 2-企业 3-商户
     */
    public class HomeRequestBody {
        public String activityShop;
        public String isPublish;


        public HomeRequestBody(String activityShop, String isPublish) {
            this.activityShop = activityShop;
            this.isPublish = isPublish;
        }
    }
    /**
     * "isPublish": 传APP类型 1-消费者 2-企业 3-商户
     */
    public class ConsultationRequestBody {
        public String appSide;

        public ConsultationRequestBody(String appSide) {
            this.appSide = appSide;
        }
    }
}
