package com.xx.hbhconsumer.data.http.requst;

import com.xx.hbhconsumer.data.http.BaseRespons;
import com.xx.hbhconsumer.data.http.respons.RecruitBean;

import java.util.List;

import io.reactivex.rxjava3.core.Observable;
import me.goldze.mvvmhabit.http.ApiParams;
import me.goldze.mvvmhabit.http.BasePageResponse;
import me.goldze.mvvmhabit.http.BaseResponse;
import okhttp3.RequestBody;

public class RecruitRequest extends BaseRespons {

    public Observable<BaseResponse<Integer>> recruitment(String recruitmentId, String resumeFileId) {
        ApiParams<RecruitmentRequestBody> apiParams = new ApiParams<>();
        RecruitmentRequestBody requestBody = new RecruitmentRequestBody("1", recruitmentId, resumeFileId);
        RequestBody body=apiParams.setParams(requestBody);
        return getApiService().recruitment(body);
    }

    public Observable<BasePageResponse<RecruitBean>> queryAppRecruitmentList(String recruitmentType) {

        ApiParams<QueryAppRecruitmentListRequestBody> apiParams = new ApiParams<>();
        QueryAppRecruitmentListRequestBody requestBody = new QueryAppRecruitmentListRequestBody(recruitmentType);
        RequestBody body=apiParams.setParams(requestBody);
        return getApiService().queryAppRecruitmentList(body);
    }

    public Observable<BaseResponse<RecruitBean>> queryAppRecruitmentDetail(String businessId) {
        return getApiService().queryAppRecruitmentDetail(businessId);
    }

    public class QueryAppRecruitmentListRequestBody {
        public String recruitmentType;

        public QueryAppRecruitmentListRequestBody(String recruitmentType) {
            this.recruitmentType = recruitmentType;
        }
    }
    public class RecruitmentRequestBody {
        public String appSide;
        public String recruitmentId;
        public String resumeFileId;

        public RecruitmentRequestBody(String appSide, String recruitmentId, String resumeFileId) {
            this.appSide = appSide;
            this.recruitmentId = recruitmentId;
            this.resumeFileId = resumeFileId;
        }
    }
}
