package com.xx.hbhconsumer.ui.category;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.CategoryRequest;
import com.xx.hbhconsumer.data.http.respons.CategoryBean;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class CategoryViewModel extends BaseViewModel<CategoryRequest> {

    public MutableLiveData<List<CategoryBean>> categoryBeanList = new  MutableLiveData<>(new ArrayList<>());
    public MutableLiveData<List<CategoryBean>> secondBeanList = new  MutableLiveData<>(new ArrayList<>());

    public CategoryViewModel(@NonNull Application application) {
        super(application);
    }

    public CategoryViewModel(@NonNull Application application, CategoryRequest model) {
        super(application, model);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        loadData();
    }

    private void loadData() {
        model.getCategoryTree()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(CategoryViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<CategoryBean>>() {
                    @Override
                    public void onSuccess(List<CategoryBean> resultBean) {
                        categoryBeanList.postValue(resultBean);
                        secondBeanList.postValue(resultBean.get(0).getChildren());
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }
}
