package com.xx.hbhconsumer.ui.credit;

import android.os.Bundle;

import com.google.android.material.tabs.TabLayout;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.CreditAdapter;
import com.xx.hbhconsumer.data.http.requst.CreditRequest;
import com.xx.hbhconsumer.databinding.ActivityCreditDetailBinding;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class CreditDetailActivity extends BaseActivity<ActivityCreditDetailBinding, CreditDetailViewModel> {

    @Override
    public void initData() {
        super.initData();

        /*切换状态Tab*/
        binding.tabLayout.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            /*订单状态 1-待付款 2-已完成 3-已关闭*/
            public void onTabSelected(TabLayout.Tab tab) {
                switch (tab.getPosition()) {
                    case 0:
                        viewModel.loadCreditRecordList("1", "2022", "2023");
                        break;
                    case 1:
                        viewModel.loadCreditRecordList("2", "2022", "2023");
                        break;
                }
            }
            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
            }
            @Override
            public void onTabReselected(TabLayout.Tab tab) {
            }
        });

        viewModel.creditRecordBeanList.observe(this, creditRecordBeanList -> {
            CreditAdapter creditAdapter = new CreditAdapter(this);
            //把adapterset进去
            binding.rvCreditRecordList.setAdapter(creditAdapter);
            creditAdapter.mList = creditRecordBeanList;
        });

        viewModel.credit.observe(this, credit -> {
            binding.tvCreditNum.setText(String.valueOf(credit));
        });
    }

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_credit_detail;
    }

    @Override
    public int initVariableId() {
        return BR.creditDetailViewModel;
    }

    @Override
    public CreditDetailViewModel initViewModel() {
        CreditRequest lm = new CreditRequest();
        return new CreditDetailViewModel(getApplication(), lm);
    }
}
