package com.xx.hbhconsumer.ui.credit;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.CreditRequest;
import com.xx.hbhconsumer.data.http.respons.CreditDetailBean;
import com.xx.hbhconsumer.data.http.respons.CreditRecordBean;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class CreditDetailViewModel extends BaseViewModel<CreditRequest> {

    public MutableLiveData<List<CreditRecordBean>> creditRecordBeanList = new  MutableLiveData<>(new ArrayList<>());
    public MutableLiveData<Integer> credit = new MutableLiveData<>(0);

    public CreditDetailViewModel(@NonNull Application application) {
        super(application);
    }

    public CreditDetailViewModel(@NonNull Application application, CreditRequest model) {
        super(application, model);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        loadCreditRecordList("1", "2022", "2023");
    }

    public void getMyPoint() {
        model.getMyPoint()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(CreditDetailViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<CreditDetailBean>() {
                    @Override
                    public void onSuccess(CreditDetailBean resultBean) {
                        credit.postValue(resultBean.getIntegralTotal());
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                });
    }

    public void loadCreditRecordList(String incomeType, String beginTime, String endTime) {
        model.getCreditRecordList(incomeType, beginTime, endTime)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(CreditDetailViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<CreditRecordBean>() {
                    @Override
                    public void onSuccess(List<CreditRecordBean> resultBean) {
                        creditRecordBeanList.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {

                    }

                });
    }
}
