package com.xx.hbhconsumer.ui.credit;

import android.os.Bundle;

import androidx.recyclerview.widget.GridLayoutManager;

import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.CreditGoodsAdapter;
import com.xx.hbhconsumer.adapter.CreditGoodsSmallAdapter;
import com.xx.hbhconsumer.data.http.requst.CreditRequest;
import com.xx.hbhconsumer.databinding.ActivityCreditsExchangeBinding;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class CreditsExchangeActivity extends BaseActivity<ActivityCreditsExchangeBinding, CreditsExchangeViewModel> {

    @Override
    public void initData() {
        super.initData();

        viewModel.creditGoodsBeanList.observe(this, creditGoodsBeanList -> {
            GridLayoutManager manager = new GridLayoutManager(this,2);
            binding.rvAllGoodsList.setLayoutManager(manager);
            //获取适配器上下文
            CreditGoodsAdapter creditGoodsAdapter = new CreditGoodsAdapter(this);
            //把adapterset进去
            binding.rvAllGoodsList.setAdapter(creditGoodsAdapter);
            creditGoodsAdapter.mList = creditGoodsBeanList;
            creditGoodsAdapter.setOnItemClick((position, data) -> viewModel.goCreditsGoodsDetail(data.getBusinessId()));
        });

        viewModel.topCreditGoodsBeanList.observe(this, topCreditGoodsBeanList -> {
            //获取适配器上下文
            CreditGoodsSmallAdapter creditGoodsSmallAdapter = new CreditGoodsSmallAdapter(this);
            GridLayoutManager manager1 = new GridLayoutManager(this,3);
            binding.rvRecommendList.setLayoutManager(manager1);
            //把adapterset进去
            binding.rvRecommendList.setAdapter(creditGoodsSmallAdapter);
            creditGoodsSmallAdapter.mList = topCreditGoodsBeanList;
            creditGoodsSmallAdapter.setOnItemClick((position, data) -> viewModel.goCreditsGoodsDetail(data.getBusinessId()));
        });
    }

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_credits_exchange;
    }

    @Override
    public int initVariableId() {
        return BR.creditsExchangeViewModel;
    }

    @Override
    public CreditsExchangeViewModel initViewModel() {
        CreditRequest lm = new CreditRequest();
        return new CreditsExchangeViewModel(getApplication(), lm);
    }
}
