package com.xx.hbhconsumer.ui.credit;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.CreditRequest;
import com.xx.hbhconsumer.data.http.respons.CreditGoodsBean;
import com.xx.hbhconsumer.data.http.respons.CreditRecordBean;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class MyCreditViewModel extends BaseViewModel<CreditRequest> {

    public MutableLiveData<List<CreditGoodsBean>> creditGoodsBeanList = new  MutableLiveData<>(new ArrayList<>());
    public MutableLiveData<List<CreditRecordBean>> creditRecordBeanList = new  MutableLiveData<>(new ArrayList<>());

    public MyCreditViewModel(@NonNull Application application) {
        super(application);
    }

    public MyCreditViewModel(@NonNull Application application, CreditRequest model) {
        super(application, model);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        loadGoodsList();
        loadCreditRecordList();
    }

    private void loadCreditRecordList() {
        model.getCreditRecordList(null, null, null)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MyCreditViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<CreditRecordBean>() {
                    @Override
                    public void onSuccess(List<CreditRecordBean> resultBean) {
                        creditRecordBeanList.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {

                    }

                });
    }

    private void loadGoodsList() {
        model.getCreditGoodsList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MyCreditViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<CreditGoodsBean>() {
                    @Override
                    public void onSuccess(List<CreditGoodsBean> resultBean) {
                        creditGoodsBeanList.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {
                        
                    }

                });
    }


    public BindingCommand goCreditDetail = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(CreditDetailActivity.class);
        }

    });

    public BindingCommand goCreditDescription = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(CreditDescriptionActivity.class);
        }

    });

    public BindingCommand goCreditsExchange = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(CreditsExchangeActivity.class);
        }

    });
}
