package com.xx.hbhconsumer.ui.creditorder;

import android.os.Bundle;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.requst.CreditOrderRequest;
import com.xx.hbhconsumer.databinding.ActivityCreditOrderDetailBinding;
import com.xx.hbhconsumer.utils.RetrofitClient;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class CreditOrderDetailActivity extends BaseActivity<ActivityCreditOrderDetailBinding, CreditOrderDetailViewModel> {

    @Override
    public void initData() {
        super.initData();
        viewModel.orderBean.observe(this, orderBean -> {

            if (orderBean != null) {
                Glide.with(this)
                        .load(RetrofitClient.baseImgUrl + orderBean.getIntegralCommodityImageUrl().get(0))
                        .into(binding.ivShopLogo);

                if ("0".equals(orderBean.getStatus())) {
                    binding.ivOrderStateIcon.setImageDrawable(getDrawable(R.mipmap.jifendingdan_icon_yiwancheng));
                    binding.tvOrderState.setText("已完成");
                } else if ("1".equals(orderBean.getStatus())) {
                    binding.ivOrderStateIcon.setImageDrawable(getDrawable(R.mipmap.jifendingdan_icon_dailing));
                    binding.tvOrderState.setText("待领取");
                }
                binding.tvTotalCredit.setText(orderBean.getConsumptionPoints() + " 积分");
                binding.tvOrderNumber.setText(orderBean.getPointOrderNumber());
                binding.tvOrderTime.setText(orderBean.getCreateTime());
            }
        });
    }

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_credit_order_detail;
    }

    @Override
    public int initVariableId() {
        return BR.creditOrderDetailViewModel;
    }


    @Override
    public CreditOrderDetailViewModel initViewModel() {
        CreditOrderRequest model = new CreditOrderRequest();
        String orderId = getIntent().getStringExtra("orderId");
        return new CreditOrderDetailViewModel(getApplication(), model, orderId);
    }
}
