package com.xx.hbhconsumer.ui.creditorder;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.CreditOrderRequest;
import com.xx.hbhconsumer.data.http.requst.PhoneRequest;
import com.xx.hbhconsumer.data.http.respons.CreditOrderBean;
import com.xx.hbhconsumer.data.http.respons.OrderBean;

import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class CreditOrderDetailViewModel extends BaseViewModel<CreditOrderRequest> {

    private String orderId;


    public MutableLiveData<CreditOrderBean> orderBean = new  MutableLiveData<>(null);

    public CreditOrderDetailViewModel(@NonNull Application application) {
        super(application);
    }

    public CreditOrderDetailViewModel(@NonNull Application application, CreditOrderRequest model, String orderId) {
        super(application, model);
        this.orderId = orderId;
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        loadData();
    }

    private void loadData() {
        model.getCreditOrderDetail(orderId)
                .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                .doOnSubscribe(CreditOrderDetailViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<CreditOrderBean>() {
                    @Override
                    public void onSuccess(CreditOrderBean creditOrderBean) {
                        orderBean.postValue(creditOrderBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                });
    }
}
