package com.xx.hbhconsumer.ui.creditorder;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.Nullable;

import com.xx.hbhconsumer.BR;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.CreditOrderAdapter;
import com.xx.hbhconsumer.data.http.requst.CreditOrderRequest;
import com.xx.hbhconsumer.databinding.FragmentCreditOrderListBinding;

import me.goldze.mvvmhabit.base.BaseFragment;

public class CreditOrderListFragment extends BaseFragment<FragmentCreditOrderListBinding, CreditOrderListViewModel> {

    public static CreditOrderListFragment newInstance(Integer orderType) {
        Bundle args = new Bundle();
        args.putInt("orderStatus", orderType);
        CreditOrderListFragment fragment = new CreditOrderListFragment();
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void initData() {

        viewModel.orderList.observe(this, orderBeanList -> {
            //获取适配器上下文
            CreditOrderAdapter orderListAdapter = new CreditOrderAdapter(getActivity());
            //把adapterset进去
            binding.rvOrderList.setAdapter(orderListAdapter);
            orderListAdapter.mList = orderBeanList;
            orderListAdapter.setOnItemClick((position, data) -> viewModel.goOrderDetail(data.getBusinessId()));
        });
    }

    @Override
    public int viewModelType() {
        return 1;
    }

    @Override
    public int initContentView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return R.layout.fragment_credit_order_list;
    }

    @Override
    public int initVariableId() {
        return BR.orderListViewModel;
    }

    @Override
    public CreditOrderListViewModel initViewModel() {
        CreditOrderRequest model = new CreditOrderRequest();
        Bundle args = getArguments();
        Integer orderStatus = args.getInt("orderStatus");
        String status = "";
        if (orderStatus == 1) {
            status = "2";
        } else if (orderStatus == 2) {
            status = "1";
        }
        return new CreditOrderListViewModel(getActivity().getApplication(), model, status);
    }
}
