package com.xx.hbhconsumer.ui.good;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;

import com.xx.hbhconsumer.data.http.requst.MineRequest;
import com.xx.hbhconsumer.data.local.LocalData;
import com.xx.hbhconsumer.ui.phone.PhoneActivity;
import com.xx.hbhconsumer.ui.pwd.PwdActivity;

import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;

public class GoodViewModel extends BaseViewModel<MineRequest> {
    //昵称的绑定
    public ObservableField<String> nickName = new ObservableField<>("");
    //创建时间的绑定
    public ObservableField<String> createTime = new ObservableField<>("");
    //职位的绑定
    public ObservableField<String> roleName = new ObservableField<>("");

    public GoodViewModel(@NonNull Application application) {
        super(application);
    }

    public GoodViewModel(@NonNull Application application, MineRequest model) {
        super(application, model);
    }
    private void setValueToNickName() {
        nickName.set(LocalData.getUser().getNickName());
        createTime.set(LocalData.getUser().getCreateTime());
        roleName.set(LocalData.getUser().getRoles().get(0).getRoleName());

    }
    public void refreshNickName() {
        setValueToNickName();
    }
    //跳转修改密码界面
    public BindingCommand goChangePwd = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(PwdActivity.class);
        }

    });
    //跳转修改手机号界面
    public BindingCommand goChangePhone = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(PhoneActivity.class);
        }

    });
}