package com.xx.hbhconsumer.ui.home;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.Nullable;
import androidx.lifecycle.Observer;
import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.LinearLayoutManager;

import com.xx.hbhconsumer.BR;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.GuessLikeGoodsAdapter;
import com.xx.hbhconsumer.adapter.LowPricedGoodsAdapter;
import com.xx.hbhconsumer.data.http.requst.HomeRequest;
import com.xx.hbhconsumer.data.http.respons.AdvertisingBean;
import com.xx.hbhconsumer.data.http.respons.GuessLikeGoodsBean;
import com.xx.hbhconsumer.data.http.respons.LowPriceGoodsBean;
import com.xx.hbhconsumer.databinding.FragmentHomeBinding;
import com.youth.banner.indicator.CircleIndicator;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseFragment;

public class HomeFragment extends BaseFragment<FragmentHomeBinding, HomeViewModel> {
    @Override
    public void initData() {
        super.initData();
        binding.banner.addBannerLifecycleObserver(this).setIndicator(new CircleIndicator(requireContext()));
        viewModel.hasUnReadMessage.observe(this, new Observer<Boolean>() {
            @Override
            public void onChanged(Boolean hasUnReadMessageFlag) {
                if (hasUnReadMessageFlag) {
                    binding.ivMessage.setImageDrawable(getContext().getDrawable(R.mipmap.wode_icon_xiaoxi2));
                } else {
                    binding.ivMessage.setImageDrawable(getContext().getDrawable(R.mipmap.wode_icon_xiaoxi1));
                }
            }
        });

        viewModel.AdvertisingList.observe(this, new Observer<List<AdvertisingBean>>() {
            @Override
            public void onChanged(List<AdvertisingBean> advertisingBeans) {

                BannerAdapter bannerAdapter=new BannerAdapter(requireContext(), advertisingBeans);
                binding.banner.setAdapter(bannerAdapter);
            }
        });

        viewModel.LowPriceGoodsList.observe(this, new Observer<List<LowPriceGoodsBean>>() {
            @Override
            public void onChanged(List<LowPriceGoodsBean> lowPriceGoodsBeanList) {
                //获取适配器上下文
                LowPricedGoodsAdapter lowPricedGoodsAdapter = new LowPricedGoodsAdapter(getActivity());
                LinearLayoutManager layoutManager = new LinearLayoutManager(getActivity());
                layoutManager.setOrientation(LinearLayoutManager.HORIZONTAL);
                binding.rvLowPricedGoods.setLayoutManager(layoutManager);
                //把adapterset进去
                binding.rvLowPricedGoods.setAdapter(lowPricedGoodsAdapter);
                lowPricedGoodsAdapter.mList = lowPriceGoodsBeanList;
            }
        });

        viewModel.GuessLikeGoodsList.observe(this, new Observer<List<GuessLikeGoodsBean>>() {
            @Override
            public void onChanged(List<GuessLikeGoodsBean> guessLikeGoodsBeanList) {
                //获取适配器上下文
                GridLayoutManager manager = new GridLayoutManager(getActivity(),2);
                binding.rvGuessLike.setLayoutManager(manager);
                //获取适配器上下文
                GuessLikeGoodsAdapter rvGuessLikeListAdapter = new GuessLikeGoodsAdapter(getActivity());
                //把adapterset进去
                binding.rvGuessLike.setAdapter(rvGuessLikeListAdapter);
                rvGuessLikeListAdapter.mList = guessLikeGoodsBeanList;
            }
        });
    }

    @Override
    public int viewModelType() {
        return 1;
    }

    @Override
    public int initContentView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return R.layout.fragment_home;
    }

    @Override
    public int initVariableId() {
        return BR.homeViewModel;
    }

    @Override
    public HomeViewModel initViewModel() {
        HomeRequest lm = new HomeRequest();
        return new HomeViewModel(getActivity().getApplication(), lm);
    }
}
