package com.xx.hbhconsumer.ui.home;

import android.app.Application;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.HomeRequest;
import com.xx.hbhconsumer.data.http.respons.AdvertisingBean;
import com.xx.hbhconsumer.data.http.respons.GuessLikeGoodsBean;
import com.xx.hbhconsumer.data.http.respons.LowPriceGoodsBean;
import com.xx.hbhconsumer.data.http.respons.MerchantBean;
import com.xx.hbhconsumer.data.http.respons.MessageBean;
import com.xx.hbhconsumer.data.local.LocalData;
import com.xx.hbhconsumer.ui.credit.CreditDetailActivity;
import com.xx.hbhconsumer.ui.credit.CreditsExchangeActivity;
import com.xx.hbhconsumer.ui.hbh.HbhActivity;
import com.xx.hbhconsumer.ui.hotsales.HotSalesActivity;
import com.xx.hbhconsumer.ui.messagecenter.MessageCenterActivity;
import com.xx.hbhconsumer.ui.newproducts.NewProductsActivity;
import com.xx.hbhconsumer.ui.recruit.RecruitActivity;
import com.xx.hbhconsumer.ui.search.SearchActivity;
import com.xx.hbhconsumer.ui.storeservices.StoreServicesActivity;
import com.xx.xxviewlibrary.base.xxBaseDialog;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class HomeViewModel extends BaseViewModel<HomeRequest> {

    //    创建活动中心实体对象
    public MutableLiveData<Boolean> signFlag = new MutableLiveData<>(false);
    public MutableLiveData<List<AdvertisingBean>> AdvertisingList = new MutableLiveData<>(new ArrayList<>());

    public MutableLiveData<List<LowPriceGoodsBean>> LowPriceGoodsList = new  MutableLiveData<>(new ArrayList<>());
    public MutableLiveData<List<GuessLikeGoodsBean>> GuessLikeGoodsList = new  MutableLiveData<>(new ArrayList<>());

    public MutableLiveData<Boolean> hasUnReadMessage = new MutableLiveData<>(false);

    public HomeViewModel(@NonNull Application application) {
        super(application);
    }

    public HomeViewModel(@NonNull Application application, HomeRequest model) {
        super(application, model);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        getADList();
        getMessageList();
        getLowPriceList("1");
        getGuessLikeGoodsList("1");
    }

    public void getMessageList() {
        model.getMessageList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(HomeViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<MessageBean>>() {
                    @Override
                    public void onSuccess(List<MessageBean> messageBeanList) {
                        if (messageBeanList != null && messageBeanList.size() > 0) {
                            hasUnReadMessage.postValue(true);
                        } else {
                            hasUnReadMessage.postValue(false);
                        }
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }

    public void getADList() {
        model.getAdList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(HomeViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<AdvertisingBean>>() {
                    @Override
                    public void onSuccess(List<AdvertisingBean> resultBean) {
                        AdvertisingList.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }


    public void getLowPriceList(String affiliatedCompany) {
        model.getLowPriceList(affiliatedCompany)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(HomeViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<LowPriceGoodsBean>>() {
                    @Override
                    public void onSuccess(List<LowPriceGoodsBean> resultBean) {
                        LowPriceGoodsList.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }

    public void getGuessLikeGoodsList(String affiliatedCompany) {
        model.getGuessLikeGood(affiliatedCompany)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(HomeViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<GuessLikeGoodsBean>>() {
                    @Override
                    public void onSuccess(List<GuessLikeGoodsBean> resultBean) {
                        GuessLikeGoodsList.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }


    public void memberSign(View view) {
        showSignDialog(view);
        model.memberSign("1")
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(HomeViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<Boolean>() {
                    @Override
                    public void onSuccess(Boolean resultBean) {
                        showSignDialog(view);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }

    private void showSignDialog(View view) {
        SignDialog dialog=new SignDialog(view.getContext(), 1);
        dialog.setDialogClickListener((xxBaseDialog.onDialogClickListener<SignDialog.SignCurrent>) (code, data) -> startActivity(CreditDetailActivity.class));
        dialog.show();
    }

    //跳转诉求反馈
    public BindingCommand goStoreServices = new BindingCommand(() -> startActivity(StoreServicesActivity.class));

    //跳转com.xx
    public BindingCommand goCreditsExchange = new BindingCommand(() -> startActivity(CreditsExchangeActivity.class));
    //跳转订单管理
    public BindingCommand goRecruit = new BindingCommand(() -> startActivity(RecruitActivity.class));

    //跳转店铺信息
    public BindingCommand goHbh = new BindingCommand(() -> startActivity(HbhActivity.class));

    //跳转店铺信息
    public BindingCommand goSearch = new BindingCommand(() -> startActivity(SearchActivity.class));

    //跳转店铺信息
    public BindingCommand goNewProducts = new BindingCommand(() -> startActivity(NewProductsActivity.class));
    //跳转店铺信息
    public BindingCommand goHotSales = new BindingCommand(() -> startActivity(HotSalesActivity.class));

    //跳转店铺信息
    public BindingCommand goMessageCenter = new BindingCommand(() -> startActivity(MessageCenterActivity.class));
}
