package com.xx.hbhconsumer.ui.hotsales;

import android.os.Bundle;

import androidx.lifecycle.Observer;
import androidx.recyclerview.widget.GridLayoutManager;

import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.HotSalesGoodsAdapter;
import com.xx.hbhconsumer.adapter.HotSalesTop3GoodsAdapter;
import com.xx.hbhconsumer.adapter.NewProductsGoodsAdapter;
import com.xx.hbhconsumer.data.http.requst.HotSalesRequest;
import com.xx.hbhconsumer.data.http.requst.NewCommodityRequest;
import com.xx.hbhconsumer.data.http.respons.HotSalesBean;
import com.xx.hbhconsumer.data.http.respons.NewCommodityBean;
import com.xx.hbhconsumer.databinding.ActivityHotSalesBinding;
import com.xx.hbhconsumer.databinding.ActivityNewProductsBinding;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class HotSalesActivity extends BaseActivity<ActivityHotSalesBinding, HotSalesViewModel> {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_hot_sales;
    }

    @Override
    public int initVariableId() {
        return BR.hotSalesViewModel;
    }

    @Override
    public void initData() {
        super.initData();
        viewModel.hotSalesList.observe(this, new Observer<List<HotSalesBean>>() {
            @Override
            public void onChanged(List<HotSalesBean> hotSalesBeanList) {

                HotSalesTop3GoodsAdapter hotSalesTop3GoodsAdapter = new HotSalesTop3GoodsAdapter(HotSalesActivity.this);
                HotSalesGoodsAdapter hotSalesGoodsAdapter = new HotSalesGoodsAdapter(HotSalesActivity.this);
                if (hotSalesBeanList.size() <= 3) {
                    binding.rvGoodsTop3List.setAdapter(hotSalesTop3GoodsAdapter);
                    hotSalesTop3GoodsAdapter.mList = hotSalesBeanList;
                } else {
                    binding.rvGoodsTop3List.setAdapter(hotSalesTop3GoodsAdapter);
                    hotSalesTop3GoodsAdapter.mList = hotSalesBeanList.subList(0, 3);

                    binding.rvGoodsList.setAdapter(hotSalesGoodsAdapter);
                    hotSalesGoodsAdapter.mList = hotSalesBeanList.subList(3, hotSalesBeanList.size());
                }
            }
        });

    }

    @Override
    public HotSalesViewModel initViewModel() {
        HotSalesRequest lm = new HotSalesRequest();
        return new HotSalesViewModel(getApplication(), lm);
    }
}
