package com.xx.hbhconsumer.ui.hotsales;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.HotSalesRequest;
import com.xx.hbhconsumer.data.http.requst.NewCommodityRequest;
import com.xx.hbhconsumer.data.http.respons.HotSalesBean;
import com.xx.hbhconsumer.data.http.respons.NewCommodityBean;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class HotSalesViewModel extends BaseViewModel<HotSalesRequest> {

    public MutableLiveData<List<HotSalesBean>> hotSalesList = new  MutableLiveData<>(new ArrayList<>());

    public HotSalesViewModel(@NonNull Application application) {
        super(application);
    }

    public HotSalesViewModel(@NonNull Application application, HotSalesRequest model) {
        super(application, model);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        loadData();
    }

    private void loadData() {
        model.hotSales("1")
                .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                .doOnSubscribe(HotSalesViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<HotSalesBean>() {
                    @Override
                    public void onSuccess(List<HotSalesBean> newCommodityBeanList) {
                        hotSalesList.postValue(newCommodityBeanList);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {

                    }


                });
    }

}
