package com.xx.hbhconsumer.ui.login

import android.os.Bundle
import androidx.lifecycle.Observer
import androidx.recyclerview.widget.GridLayoutManager
import com.jakewharton.rxbinding3.widget.checked
import com.jakewharton.rxbinding3.widget.checkedChanges
import com.xx.hbhconsumer.BR
import com.xx.hbhconsumer.R
import com.xx.hbhconsumer.adapter.CollectionGoodsAdapter
import com.xx.hbhconsumer.data.http.requst.LoginRequest
import com.xx.hbhconsumer.data.http.respons.CollectionBean
import com.xx.hbhconsumer.databinding.ActivityLoginBinding
import me.goldze.mvvmhabit.base.BaseActivity

class LoginActivity() : BaseActivity<ActivityLoginBinding, LoginViewModel>() {


    override fun initContentView(savedInstanceState: Bundle?): Int {

        return R.layout.activity_login

    }

    override fun initVariableId(): Int {
        return BR.loginViewModel
    }

    override fun initData() {
        super.initData()

        viewModel.consentAgreementFlag.observe(this,
            Observer<Boolean> { consentAgreementFlag ->
                if (binding.rbLoginAgreement.isSelected) {
                    binding.radioSelectedGroup.clearCheck()
                } else {
                    binding.rbLoginAgreement.setSelected(consentAgreementFlag)
                }
            })

    }

    override fun initViewObservable() {
        super.initViewObservable()
    }

    override fun initViewModel(): LoginViewModel {
        val lm: LoginRequest = LoginRequest()
        return LoginViewModel(application,lm)
    }

}