package com.xx.hbhconsumer.ui.login;

import static me.goldze.mvvmhabit.utils.Utils.Interceptor_TOKEN;

import android.app.Application;
import android.os.Bundle;
import android.text.TextUtils;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.LoginRequest;
import com.xx.hbhconsumer.data.http.respons.CollectionBean;
import com.xx.hbhconsumer.data.http.respons.UserInfoBean;
import com.xx.hbhconsumer.data.local.LocalData;
import com.xx.hbhconsumer.ui.main.MainActivity;
import com.xx.hbhconsumer.ui.privacyclause.PrivacyClauseActivity;
import com.xx.hbhconsumer.ui.pwd.ForgetPwdActivity;
import com.xx.hbhconsumer.ui.register.RegisterActivity;
import com.xx.hbhconsumer.ui.useragreement.UserAgreementActivity;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;

public class LoginViewModel extends BaseViewModel<LoginRequest> {

    public MutableLiveData<Boolean> consentAgreementFlag = new  MutableLiveData<>(false);
    //用户名的绑定
    public ObservableField<String> userName = new ObservableField<>("");
    //密码的绑定
    public ObservableField<String> password = new ObservableField<>("");

    public LoginViewModel(@NonNull Application application, LoginRequest model) {
        super(application, model);
    }

    //跳转开店页面
    public BindingCommand goMerchantEnter = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            Bundle bundle=new Bundle();
//            bundle.putInt("pageStep", R.id.registerMaterialFragment);
//            startActivity(MerchantEnterActivity.class,bundle);
        }
    });

    public BindingCommand consentAgreement = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            if (consentAgreementFlag.getValue()) {
                consentAgreementFlag.postValue(false);
            } else {
                consentAgreementFlag.postValue(true);
            }

        }

    });


    public BindingCommand goPrivacyClause = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(PrivacyClauseActivity.class);
        }

    });

    public BindingCommand goUserAgreement = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(UserAgreementActivity.class);
        }

    });

    //跳转首页
    public BindingCommand goRegister = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(RegisterActivity.class);
        }

    });

    //跳转忘记密码
    public BindingCommand forgetPwd = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(ForgetPwdActivity.class);
        }

    });
    //登陆
    public BindingCommand login = new BindingCommand(new BindingAction() {
        @Override
        public void call() {

            if (TextUtils.isEmpty(userName.get().toString())) {
                ToastUtils.showShort("请输入账号！");
            }else if (TextUtils.isEmpty(password.get().toString())) {
                ToastUtils.showShort("请输入密码！");
            }else if (!consentAgreementFlag.getValue()) {
                ToastUtils.showShort("请勾选同意协议");
            }else {
                model.Login(/*userName.get().toString(), password.get().toString()*/"15849509183","123456")
                        .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                        .doOnSubscribe(LoginViewModel.this)
                        .doOnSubscribe(new Consumer<Disposable>() {
                            @Override
                            public void accept(Disposable disposable) throws Exception {
                                showDialog("正在请求...");
                            }
                        }).subscribe(new ApiDisposableObserver<String>() {
                            @Override
                            public void onSuccess(String resultBean) {
                                //是指token
                                Interceptor_TOKEN = "Bearer " + resultBean;
                                getuserInfo();
                            }

                            @Override
                            public void onError(String Error) {
                                dismissDialog();
                            }

                        });
            }
        }
    });



    public void getuserInfo()
    {
        model.getUserInfo()
                .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                .doOnSubscribe(LoginViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<UserInfoBean>() {
                    @Override
                    public void onSuccess(UserInfoBean resultBean) {

                        //将用户信息存储到本地
                        LocalData.saveUser(resultBean.getUser());
                        dismissDialog();
                        startActivity(MainActivity.class);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }


}


