package com.xx.hbhconsumer.ui.logoff;

import static me.goldze.mvvmhabit.utils.Utils.Interceptor_TOKEN;

import android.app.Application;
import android.text.TextUtils;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;

import com.xx.hbhconsumer.data.http.requst.ForgetPwdRequest;
import com.xx.hbhconsumer.ui.login.LoginActivity;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;

public class LogoffFirstStepViewModel extends BaseViewModel<ForgetPwdRequest> {
    //用户名的绑定
    public ObservableField<String> phone = new ObservableField<>("");
    //密码的绑定
    public ObservableField<String> code = new ObservableField<>("");
    public ObservableField<String> password = new ObservableField<>("");
    public ObservableField<String> confirmPassword = new ObservableField<>("");

    public LogoffFirstStepViewModel(@NonNull Application application) {
        super(application);
    }

    public LogoffFirstStepViewModel(@NonNull Application application, ForgetPwdRequest model) {
        super(application, model);
    }

    // 触发确认按钮
    public BindingCommand confirm = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            if (TextUtils.isEmpty(phone.get().toString())) {
                ToastUtils.showShort("请输入手机号！");
            } else if (TextUtils.isEmpty(code.get().toString())) {
                ToastUtils.showShort("请输入验证码！");
            } else if (TextUtils.isEmpty(password.get().toString())) {
                ToastUtils.showShort("请输入登录密码！");
            } else if (TextUtils.isEmpty(confirmPassword.get().toString())) {
                ToastUtils.showShort("请再次输入登录密码！");
            } else if (!password.get().toString().equals(confirmPassword.get().toString())) {
                ToastUtils.showShort("前后密码不一致！");
            } else {
                model.ForegetPwd(phone.get().toString(), password.get().toString(),code.get().toString())
                        .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                        .doOnSubscribe(LogoffFirstStepViewModel.this)
                        .doOnSubscribe(new Consumer<Disposable>() {
                            @Override
                            public void accept(Disposable disposable) throws Exception {
                                showDialog("正在请求...");
                            }
                        }).subscribe(new ApiDisposableObserver<String>() {
                            @Override
                            public void onSuccess(String resultBean) {
                                //是指token
                                Interceptor_TOKEN = "Bearer " + resultBean;
                                startActivity(LoginActivity.class);
                            }

                            @Override
                            public void onError(String Error) {
                                dismissDialog();
                            }

                        });
            }
        }
    });

    // 跳转登录页
    public BindingCommand goLogin = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(LoginActivity.class);
        }

    });

    public BindingCommand getVerificationCode = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            if (TextUtils.isEmpty(phone.get().toString())) {
                ToastUtils.showShort("请输手机号码！");

            } else {
                model.getCode(phone.get())
                        .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                        .doOnSubscribe(LogoffFirstStepViewModel.this)
                        .doOnSubscribe(new Consumer<Disposable>() {
                            @Override
                            public void accept(Disposable disposable) throws Exception {
                                showDialog("正在请求...");
                            }
                        }).subscribe(new ApiDisposableObserver<String>() {
                            @Override
                            public void onSuccess(String resultBean) {
                                dismissDialog();
                                ToastUtils.showShort("发送成功！");
                            }

                            @Override
                            public void onError(String Error) {
                                dismissDialog();
                            }

                        });
            }
        }
    });
}
