package com.xx.hbhconsumer.ui.main;

import android.os.Bundle;

import androidx.fragment.app.Fragment;

import com.google.android.material.bottomnavigation.BottomNavigationView;
import com.xx.hbhconsumer.BR;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.databinding.ActivityMainBinding;
import com.xx.hbhconsumer.ui.activity.ActivityFragment;
import com.xx.hbhconsumer.ui.good.GoodFragment;
import com.xx.hbhconsumer.ui.home.HomeFragment;
import com.xx.hbhconsumer.ui.mine.MineFragment;
import com.xx.hbhconsumer.ui.shop.ShopFragment;

import me.goldze.mvvmhabit.base.BaseActivity;

public class MainActivity extends BaseActivity<ActivityMainBinding, MainViewModel> {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_main;
    }


    @Override
    public void initData() {
        super.initData();
        // 初始化底部导航栏
        BottomNavigationView bottomNavigationView = findViewById(R.id.bottom_navigation_view);
        bottomNavigationView.setOnNavigationItemSelectedListener(navItemSelectedListener);

        // 显示默认的 Fragment
        getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, new HomeFragment()).commit();


    }
    @Override
    public int initVariableId() {
        return BR.mainViewModel;
    }

    @Override
    public void onPointerCaptureChanged(boolean hasCapture) {
        super.onPointerCaptureChanged(hasCapture);
    }


    private final BottomNavigationView.OnNavigationItemSelectedListener navItemSelectedListener = item -> {
        Fragment selectedFragment = null;

        // 根据选项 ID 创建相应的 Fragment

        if (item.getItemId() == R.id.menu_home) {
            selectedFragment = new HomeFragment();
        } else if (item.getItemId() == R.id.menu_shop) {
            selectedFragment = new ShopFragment();
        } else if (item.getItemId() == R.id.menu_activity) {
            selectedFragment = new ActivityFragment();
        } else if (item.getItemId() == R.id.menu_good) {
            selectedFragment = new GoodFragment();
        } else if (item.getItemId() == R.id.menu_shopping_cart) {
            selectedFragment = new MineFragment();
        }


        // 替换当前显示的 Fragment
        // 确保选择项不能为空
        assert selectedFragment != null;
        getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, selectedFragment).commit();
        return true;
    };




}
