package com.xx.hbhconsumer.ui.messagecenter;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.Nullable;

import com.xx.hbhconsumer.BR;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.MessageAdapter;
import com.xx.hbhconsumer.data.http.requst.LoginRequest;
import com.xx.hbhconsumer.data.http.respons.OrderBean;
import com.xx.hbhconsumer.databinding.FragmentMessageListBinding;

import java.util.ArrayList;
import java.util.List;

import me.goldze.mvvmhabit.base.BaseFragment;

public class MessageListFragment extends BaseFragment<FragmentMessageListBinding, MessageListViewModel> {

    public static MessageListFragment newInstance(Integer orderType) {
        Bundle args = new Bundle();
        args.putInt("orderType", orderType);
        MessageListFragment fragment = new MessageListFragment();
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void initData() {
        List<OrderBean> orderBeanList = new ArrayList<>();
        //获取适配器上下文
        MessageAdapter orderListAdapter = new MessageAdapter(getActivity());

        //把adapterset进去
        binding.rvMessageList.setAdapter(orderListAdapter);
        orderListAdapter.mList = orderBeanList;

        orderListAdapter.setOnItemClick((position, data) -> viewModel.goMessageDetail(position));

    }

    @Override
    public int viewModelType() {
        return 1;
    }

    @Override
    public int initContentView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return R.layout.fragment_message_list;
    }

    @Override
    public int initVariableId() {
        return BR.messageListViewModel;
    }

    @Override
    public MessageListViewModel initViewModel() {
        LoginRequest model = new LoginRequest();
        return new MessageListViewModel(getActivity().getApplication(), model);
    }
}
