package com.xx.hbhconsumer.ui.mine;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.Nullable;
import androidx.lifecycle.Observer;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.BR;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.requst.MineRequest;
import com.xx.hbhconsumer.databinding.FragmentMineBinding;
import com.xx.hbhconsumer.utils.RetrofitClient;

import me.goldze.mvvmhabit.base.BaseFragment;

public class MineFragment extends BaseFragment<FragmentMineBinding, MineViewModel> {


    @Override
    public int viewModelType() {
        return 1;
    }

    @Override
    public int initContentView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return R.layout.fragment_mine;
    }

    @Override
    public int initVariableId() {
        return BR.mineViewModel;
    }

    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();
        viewModel.integralTotal.observe(this, integralTotal -> binding.tvPoint.setText(String.valueOf(integralTotal)));
        viewModel.memberCoupon.observe(this, memberCoupon -> binding.tvCouponNum.setText(String.valueOf(memberCoupon)));
        viewModel.userBean.observe(this, userBean -> {
            if (userBean != null) {
                binding.tvNickname.setText(userBean.getNickName());
                Glide.with(this)
                        .load(RetrofitClient.baseImgUrl + userBean.getAvatar())
                        .into(binding.ivAvatar);
            }

        });

        viewModel.hasUnReadMessage.observe(this, new Observer<Boolean>() {
            @Override
            public void onChanged(Boolean hasUnReadMessageFlag) {
                if (hasUnReadMessageFlag) {
                    binding.ivMessage.setImageDrawable(getContext().getDrawable(R.mipmap.wode_icon_xiaoxi2));
                } else {
                    binding.ivMessage.setImageDrawable(getContext().getDrawable(R.mipmap.wode_icon_xiaoxi1));
                }
            }
        });

    }


    @Override
    public MineViewModel initViewModel() {
        MineRequest lm = new MineRequest();
        return new MineViewModel(getActivity().getApplication(), lm);
    }
}