package com.xx.hbhconsumer.ui.mine;

import android.app.Application;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;
import androidx.lifecycle.MutableLiveData;

import com.huantansheng.easyphotos.callback.SelectCallback;
import com.huantansheng.easyphotos.models.album.entity.Photo;
import com.xx.hbhconsumer.data.http.requst.MineRequest;
import com.xx.hbhconsumer.data.http.respons.AdvertisingBean;
import com.xx.hbhconsumer.data.http.respons.Filebean;
import com.xx.hbhconsumer.data.http.respons.MemberInfoBean;
import com.xx.hbhconsumer.data.http.respons.MessageBean;
import com.xx.hbhconsumer.data.http.respons.MyPointBean;
import com.xx.hbhconsumer.data.http.respons.UserBean;
import com.xx.hbhconsumer.data.local.LocalData;
import com.xx.hbhconsumer.ui.credit.MyCreditActivity;
import com.xx.hbhconsumer.ui.creditorder.CreditOrderActivity;
import com.xx.hbhconsumer.ui.home.HomeViewModel;
import com.xx.hbhconsumer.ui.messagecenter.MessageCenterActivity;
import com.xx.hbhconsumer.ui.mycollection.MyCollectionActivity;
import com.xx.hbhconsumer.ui.mycoupon.MyCouponActivity;
import com.xx.hbhconsumer.ui.order.OrderActivity;
import com.xx.hbhconsumer.ui.phone.PhoneActivity;
import com.xx.hbhconsumer.ui.pwd.PwdActivity;
import com.xx.hbhconsumer.ui.settings.SettingsActivity;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class MineViewModel extends BaseViewModel<MineRequest> {
    //昵称的绑定
    public ObservableField<String> nickName = new ObservableField<>("");
    public MutableLiveData<Integer> integralTotal = new MutableLiveData<>(0);
    public MutableLiveData<String> memberCoupon = new MutableLiveData<>("0");
    //创建时间的绑定
    public ObservableField<String> createTime = new ObservableField<>("");
    //职位的绑定
    public ObservableField<String> roleName = new ObservableField<>("");
    public MutableLiveData<UserBean> userBean = new MutableLiveData<>(null);

    public MutableLiveData<Boolean> hasUnReadMessage = new MutableLiveData<>(false);

    public MineViewModel(@NonNull Application application) {
        super(application);
    }

    public MineViewModel(@NonNull Application application, MineRequest model) {
        super(application, model);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        userBean.postValue(LocalData.getUser());
        memberInfo();
        getMessageList();
    }

    public void changeAvatar(View view) {
        ChangeAvatarDialog changeAvatarDialog = new ChangeAvatarDialog(view.getContext(), this);
        changeAvatarDialog.show();
    }

    public void choosePhoto() {
        startPhotoPage(true, new SelectCallback() {
            @Override
            public void onResult(ArrayList<Photo> photos, boolean isOriginal) {

                /*Bitmap mBitmap = BitmapFactory.decodeFile(photos.get(0).path);*/
                File file = new File(photos.get(0).path);
                model.upLoadFile(file).compose(RxUtils.schedulersTransformer()) //线程调度
                        .doOnSubscribe(MineViewModel.this)
                        .doOnSubscribe (new Consumer<Disposable>() {
                            @Override
                            public void accept(Disposable disposable) throws Exception {
                                showDialog("请稍等");
                            }
                        }).subscribe(new ApiDisposableObserver<List<Filebean>>() {
                            @Override
                            public void onSuccess(List<Filebean> resultBean) {
                                dismissDialog();
                            }

                            @Override
                            public void onError(String Error) {
                                dismissDialog();
                            }


                        });
            }

            @Override
            public void onCancel() {

            }
        });
    }

    public void takePhoto() {
        startPhotoPage(true, new SelectCallback() {
            @Override
            public void onResult(ArrayList<Photo> photos, boolean isOriginal) {

                /*Bitmap mBitmap = BitmapFactory.decodeFile(photos.get(0).path);*/
                File file = new File(photos.get(0).path);
                model.upLoadFile(file).compose(RxUtils.schedulersTransformer()) //线程调度
                        .doOnSubscribe(MineViewModel.this)
                        .doOnSubscribe (new Consumer<Disposable>() {
                            @Override
                            public void accept(Disposable disposable) throws Exception {
                                showDialog("请稍等");
                            }
                        }).subscribe(new ApiDisposableObserver<List<Filebean>>() {
                            @Override
                            public void onSuccess(List<Filebean> resultBean) {
                                dismissDialog();
                            }

                            @Override
                            public void onError(String Error) {
                                dismissDialog();
                            }


                        });
            }

            @Override
            public void onCancel() {

            }
        });
    }

    /**
     *  获取积分
     */
    private void memberInfo() {
        model.memberInfo().compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MineViewModel.this)
                .doOnSubscribe((Consumer<Disposable>) disposable -> {
                }).subscribe(new ApiDisposableObserver<MemberInfoBean>() {
                    @Override
                    public void onSuccess(MemberInfoBean resultBean) {
                        integralTotal.postValue(resultBean.getUsableIntegral());
                        memberCoupon.postValue(resultBean.getMemberCoupon());
                    }
                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                });
    }

    public void getMessageList() {
        model.getMessageList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MineViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<MessageBean>>() {
                    @Override
                    public void onSuccess(List<MessageBean> messageBeanList) {
                        if (messageBeanList != null && messageBeanList.size() > 0) {
                            hasUnReadMessage.postValue(true);
                        } else {
                            hasUnReadMessage.postValue(false);
                        }
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }

    private void setValueToNickName() {
        nickName.set(LocalData.getUser().getNickName());
        createTime.set(LocalData.getUser().getCreateTime());
        roleName.set(LocalData.getUser().getRoles().get(0).getRoleName());

    }
    public void refreshNickName() {
        setValueToNickName();
    }
    //跳转修改密码界面
    public BindingCommand goMyCoupon = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(MyCouponActivity.class);
        }

    });

    public BindingCommand goMyCredit = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(MyCreditActivity.class);
        }

    });    //跳转修改密码界面
    public BindingCommand goOrder = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(OrderActivity.class);
        }

    });

    public BindingCommand goCreditOrder = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(CreditOrderActivity.class);
        }

    });

    //跳转我的收藏
    public BindingCommand goMessageCenter = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(MessageCenterActivity.class);
        }

    });

    //跳转我的收藏
    public BindingCommand goMyCollection = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(MyCollectionActivity.class);
        }

    });

    //跳转修改手机号界面
    public BindingCommand goSettings = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(SettingsActivity.class);
        }

    });
}