package com.xx.hbhconsumer.ui.mycollection;

import android.os.Bundle;
import android.view.View;

import androidx.lifecycle.Observer;
import androidx.recyclerview.widget.GridLayoutManager;

import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.CollectionGoodsAdapter;
import com.xx.hbhconsumer.data.http.requst.CollectionRequest;
import com.xx.hbhconsumer.data.http.respons.CollectionBean;
import com.xx.hbhconsumer.databinding.ActivityMyCollectionBinding;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class MyCollectionActivity extends BaseActivity<ActivityMyCollectionBinding, MyCollectionViewModel> {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_my_collection;
    }

    @Override
    public int initVariableId() {
        return BR.myCollectionViewModel;
    }

    @Override
    public void initData() {
        super.initData();

        viewModel.collectionList.observe(this, new Observer<List<CollectionBean>>() {
            @Override
            public void onChanged(List<CollectionBean> collectionBeanList) {
                GridLayoutManager manager = new GridLayoutManager(MyCollectionActivity.this,2);
                binding.rvGoodsList.setLayoutManager(manager);
                //获取适配器上下文
                CollectionGoodsAdapter collectionGoodsAdapter = new CollectionGoodsAdapter(MyCollectionActivity.this);
                //把adapterset进去
                binding.rvGoodsList.setAdapter(collectionGoodsAdapter);
                collectionGoodsAdapter.mList = collectionBeanList;
            }
        });

        viewModel.editFlag.observe(this, new Observer<Boolean>() {
            @Override
            public void onChanged(Boolean editFlag) {
               if (editFlag) {
                   binding.llBottomInfo.setVisibility(View.VISIBLE);
                   binding.tvConfirm.setVisibility(View.VISIBLE);
                   binding.tvManager.setVisibility(View.GONE);
               } else {
                   binding.llBottomInfo.setVisibility(View.GONE);

                   binding.tvConfirm.setVisibility(View.GONE);
                   binding.tvManager.setVisibility(View.VISIBLE);
               }
            }
        });


    }

    @Override
    public MyCollectionViewModel initViewModel() {
        CollectionRequest lm = new CollectionRequest();
        return new MyCollectionViewModel(getApplication(), lm);
    }
}
