package com.xx.hbhconsumer.ui.mycollection;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.CollectionRequest;
import com.xx.hbhconsumer.data.http.requst.PhoneRequest;
import com.xx.hbhconsumer.data.http.respons.CollectionBean;
import com.xx.hbhconsumer.data.http.respons.ShopBean;
import com.xx.hbhconsumer.data.http.respons.UserInfoBean;
import com.xx.hbhconsumer.data.local.LocalData;
import com.xx.hbhconsumer.ui.login.LoginViewModel;
import com.xx.hbhconsumer.ui.main.MainActivity;
import com.xx.hbhconsumer.ui.phone.PhoneActivity;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class MyCollectionViewModel extends BaseViewModel<CollectionRequest> {

    public MutableLiveData<List<CollectionBean>> collectionList = new  MutableLiveData<>(new ArrayList<>());
    public MutableLiveData<Boolean> editFlag = new  MutableLiveData<>(false);

    public MyCollectionViewModel(@NonNull Application application) {
        super(application);
    }

    public MyCollectionViewModel(@NonNull Application application, CollectionRequest model) {
        super(application, model);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        loadData();
    }

    private void loadData() {
        model.memberCollectionList("")
                .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                .doOnSubscribe(MyCollectionViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<CollectionBean>>() {
                    @Override
                    public void onSuccess(List<CollectionBean> collectionBeanList) {
                        collectionList.postValue(collectionBeanList);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }


    public BindingCommand manager = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            editFlag.postValue(true);
        }

    });

    public BindingCommand confirm = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            editFlag.postValue(false);
        }

    });
}
