package com.xx.hbhconsumer.ui.mycoupon;

import android.os.Bundle;

import androidx.lifecycle.Observer;

import com.google.android.material.tabs.TabLayout;
import com.xx.hbhconsumer.BR;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.MyCouponAdapter;
import com.xx.hbhconsumer.data.http.requst.CouponRequest;
import com.xx.hbhconsumer.data.http.respons.MyCouponBean;
import com.xx.hbhconsumer.databinding.ActivityMyCouponBinding;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;

public class MyCouponActivity extends BaseActivity<ActivityMyCouponBinding, MyCouponViewModel> {

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_my_coupon;
    }

    @Override
    public void initData() {
        super.initData();
        /*切换状态Tab*/
        binding.tabLayout.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            /*订单状态 1-待付款 2-已完成 3-已关闭*/
            public void onTabSelected(TabLayout.Tab tab) {
                viewModel.loadData(tab.getPosition());
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {
            }
        });

        viewModel.myCouponBeanList.observe(this, new Observer<List<MyCouponBean>>() {
            @Override
            public void onChanged(List<MyCouponBean> orderBeanList) {
                //获取适配器上下文
                MyCouponAdapter orderListAdapter = new MyCouponAdapter(MyCouponActivity.this);
                //把adapterset进去
                binding.rvCouponList.setAdapter(orderListAdapter);
                orderListAdapter.mList = orderBeanList;

            }
        });
    }
    @Override
    public int initVariableId() {
        return BR.myCouponViewModel;
    }

    @Override
    public void onPointerCaptureChanged(boolean hasCapture) {
        super.onPointerCaptureChanged(hasCapture);
    }

    @Override
    public MyCouponViewModel initViewModel() {
        CouponRequest loginRequest = new CouponRequest();
        return new MyCouponViewModel(getApplication(), loginRequest);
    }
}
