package com.xx.hbhconsumer.ui.mycoupon;


import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.CouponRequest;
import com.xx.hbhconsumer.data.http.requst.LoginRequest;
import com.xx.hbhconsumer.data.http.respons.MyCouponBean;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class MyCouponViewModel extends BaseViewModel<CouponRequest> {

    public MutableLiveData<List<MyCouponBean>> myCouponBeanList = new  MutableLiveData<>(new ArrayList<>());

    public MyCouponViewModel(@NonNull Application application, CouponRequest model) {
        super(application, model);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        loadData(0);
    }

    public void loadData(Integer couponState) {
        if (couponState == 0) {
            getUnUsedCouponList();
        } else {
            getUsedCouponList();
        }
    }

    private void getUnUsedCouponList() {
        model.getUnUsedCouponList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                .doOnSubscribe(MyCouponViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<MyCouponBean>() {
                    @Override
                    public void onSuccess(List<MyCouponBean> orderBeanList) {
                        myCouponBeanList.postValue(orderBeanList);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {

                    }


                });
    }

    private void getUsedCouponList() {
        model.getUsedCouponList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                .doOnSubscribe(MyCouponViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<MyCouponBean>() {
                    @Override
                    public void onSuccess(List<MyCouponBean> orderBeanList) {
                        myCouponBeanList.postValue(orderBeanList);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {

                    }


                });
    }
}


