package com.xx.hbhconsumer.ui.newproducts;

import android.os.Bundle;

import androidx.lifecycle.Observer;
import androidx.recyclerview.widget.GridLayoutManager;

import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.CollectionGoodsAdapter;
import com.xx.hbhconsumer.adapter.NewProductsGoodsAdapter;
import com.xx.hbhconsumer.data.http.requst.CollectionRequest;
import com.xx.hbhconsumer.data.http.requst.NewCommodityRequest;
import com.xx.hbhconsumer.data.http.respons.CollectionBean;
import com.xx.hbhconsumer.data.http.respons.NewCommodityBean;
import com.xx.hbhconsumer.data.http.respons.OrderBean;
import com.xx.hbhconsumer.databinding.ActivityNewProductsBinding;
import com.xx.hbhconsumer.ui.mycollection.MyCollectionActivity;
import com.xx.hbhconsumer.ui.mycollection.MyCollectionViewModel;

import java.util.ArrayList;
import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class NewProductsActivity extends BaseActivity<ActivityNewProductsBinding, NewProductsViewModel> {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_new_products;
    }

    @Override
    public int initVariableId() {
        return BR.newProductsViewModel;
    }

    @Override
    public void initData() {
        super.initData();
        viewModel.newCommodityList.observe(this, new Observer<List<NewCommodityBean>>() {
            @Override
            public void onChanged(List<NewCommodityBean> collectionBeanList) {

                //获取适配器上下文
                NewProductsGoodsAdapter orderListAdapter = new NewProductsGoodsAdapter(NewProductsActivity.this);
                //把adapterset进去
                binding.rvGoodsList.setAdapter(orderListAdapter);
                orderListAdapter.mList = collectionBeanList;

                GridLayoutManager manager = new GridLayoutManager(NewProductsActivity.this,2);
                binding.rvGoodsList.setLayoutManager(manager);
            }
        });



    }

    @Override
    public NewProductsViewModel initViewModel() {
        NewCommodityRequest lm = new NewCommodityRequest();
        return new NewProductsViewModel(getApplication(), lm);
    }
}
