package com.xx.hbhconsumer.ui.news;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.Nullable;

import com.xx.hbhconsumer.BR;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.NewsAdapter;
import com.xx.hbhconsumer.data.http.requst.LoginRequest;
import com.xx.hbhconsumer.data.http.requst.NewsRequest;
import com.xx.hbhconsumer.data.http.respons.OrderBean;
import com.xx.hbhconsumer.databinding.FragmentNewsListBinding;

import java.util.ArrayList;
import java.util.List;

import me.goldze.mvvmhabit.base.BaseFragment;

public class NewsListFragment extends BaseFragment<FragmentNewsListBinding, NewsListViewModel> {

    public static NewsListFragment newInstance(String classificationId) {
        Bundle args = new Bundle();
        args.putString("classificationId", classificationId);
        NewsListFragment fragment = new NewsListFragment();
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void initData() {

        viewModel.appInformationBeanList.observe(this, appInformationBeanList -> {
            //获取适配器上下文
            NewsAdapter orderListAdapter = new NewsAdapter(getActivity());
            //把adapterset进去
            binding.rvOrderList.setAdapter(orderListAdapter);
            orderListAdapter.mList = appInformationBeanList;
            orderListAdapter.setOnItemClick((position, data) -> viewModel.goNewsDetail(position));
        });

    }

    @Override
    public int viewModelType() {
        return 1;
    }

    @Override
    public int initContentView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return R.layout.fragment_news_list;
    }

    @Override
    public int initVariableId() {
        return BR.newsListViewModel;
    }

    @Override
    public NewsListViewModel initViewModel() {
        NewsRequest model = new NewsRequest();
        Bundle args = getArguments();
        String classificationId = args.getString("classificationId");
        return new NewsListViewModel(getActivity().getApplication(), model, classificationId);
    }
}
