package com.xx.hbhconsumer.ui.news;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.NewsRequest;
import com.xx.hbhconsumer.data.http.respons.AppInformationBean;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class NewsListViewModel extends BaseViewModel<NewsRequest> {

    public MutableLiveData<List<AppInformationBean>> appInformationBeanList = new  MutableLiveData<>(new ArrayList<>());

    String classificationId;
    public NewsListViewModel(@NonNull Application application, NewsRequest model, String classificationId) {
        super(application, model);
        this.classificationId = classificationId;
    }

    public void goNewsDetail(int position) {
        startActivity(NewsDetailActivity.class);
    }


    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        loadData();
    }

    public void loadData() {
        model.queryAppInformationList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(NewsListViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<AppInformationBean>>() {
                    @Override
                    public void onSuccess(List<AppInformationBean> resultBean) {

                        List<AppInformationBean> newResultBean = new ArrayList<>();
                        resultBean.forEach(item -> {
                            if (item.getClassificationId().equals(classificationId)) {
                                newResultBean.add(item);
                            }
                        });
                        appInformationBeanList.postValue(newResultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                });
    }
}


