package com.xx.hbhconsumer.ui.order

import android.content.Context
import android.view.Gravity
import android.view.View
import android.view.WindowManager
import com.google.android.material.tabs.TabLayout
import com.xx.hbhconsumer.R
import com.xx.hbhconsumer.adapter.AvailableCouponAdapter
import com.xx.hbhconsumer.adapter.NotAvailableCouponAdapter
import com.xx.hbhconsumer.data.http.respons.ClaimedCoupon
import com.xx.hbhconsumer.data.http.respons.CouponBean
import com.xx.hbhconsumer.databinding.DialogChooseCouponBinding
import com.xx.xxviewlibrary.base.xxBaseDialog
import me.jessyan.autosize.utils.AutoSizeUtils

class ChooseCouponDialog(context:Context, var data: ClaimedCoupon): xxBaseDialog<DialogChooseCouponBinding>(context) {

    override fun InitView(): DialogSet {
        return DialogSet(
            R.layout.dialog_choose_coupon,true,
            Gravity.BOTTOM,true, WindowManager.LayoutParams.MATCH_PARENT,
            AutoSizeUtils.dp2px(context,
            468.0F));
    }

    override fun InitData() {
        binding.chooseCouponDialog = this

        binding.btnConfirm.setOnClickListener {
            dismiss()
        }

        val couponBeanList: MutableList<CouponBean> = ArrayList()

        /*切换状态Tab*/

        binding.tabLayout.addOnTabSelectedListener(object :
            TabLayout.OnTabSelectedListener {
            override fun onTabSelected(tab: TabLayout.Tab) {
                when (tab.position) {
                    0 -> {
                        //获取适配器上下文
                        val orderListAdapter = AvailableCouponAdapter(context)
                        //把adapterset进去
                        binding.rvCouponList.setAdapter(orderListAdapter)
                        orderListAdapter.mList = data.availableCoupons
                    }

                    1 -> {
                        //获取适配器上下文
                        val orderListAdapter = NotAvailableCouponAdapter(context)
                        //把adapterset进去
                        binding.rvCouponList.setAdapter(orderListAdapter)
                        orderListAdapter.mList = data.unavailableCoupons
                    }
                }
            }

            override fun onTabUnselected(tab: TabLayout.Tab) {}
            override fun onTabReselected(tab: TabLayout.Tab) {}
        })

    }
    data class SignCurrent(val context:String)

    fun typeClickDialog(view: View) {
        if (DialogClickListener != null) {
            DialogClickListener.dialogClickBack(view.id, null)
        }
        dismiss()
    }
}