package com.xx.hbhconsumer.ui.order;

import android.os.Bundle;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.OrderGoodsAdapter;
import com.xx.hbhconsumer.data.http.requst.OrderRequest;
import com.xx.hbhconsumer.databinding.ActivityOrderDetailBinding;
import com.xx.hbhconsumer.utils.RetrofitClient;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.goldze.mvvmhabit.utils.StringUtils;
import me.tatarka.bindingcollectionadapter2.BR;

public class OrderDetailActivity extends BaseActivity<ActivityOrderDetailBinding, OrderDetailViewModel> {

    @Override
    public void initData() {
        super.initData();



        viewModel.orderBean.observe(this, orderBean -> {
            //获取适配器上下文
            OrderGoodsAdapter creditGoodsAdapter = new OrderGoodsAdapter(this);
            //把adapterset进去
            binding.rvGoodsList.setAdapter(creditGoodsAdapter);
            creditGoodsAdapter.mList = orderBean.getCommodityList();

            Glide.with(this)
                    .load(RetrofitClient.baseImgUrl + orderBean.getMerchant().getCompanyLogoFile().getUrl())
                    .into(binding.ivShopLogo);

            binding.tvShopName.setText(orderBean.getMerchant().getStoreName());
            binding.tvTotalNum.setText("共" + orderBean.getQuantity() + "件");
            binding.tvOrderNumber.setText(orderBean.getOrderNumber());
            binding.tvCreateTime.setText(orderBean.getCreateTime());

            String price = String.valueOf(orderBean.getOrderAmount());
            if (!StringUtils.isEmpty(price) && price.contains("\\.")) {
                binding.tvOrderPriceInteger.setText(price.split("\\.")[0]);
                binding.tvOrderPriceDecimal.setText("." + price.split("\\.")[1]);
            }

            String actualPrice = String.valueOf(orderBean.getActualPayment());
            if (!StringUtils.isEmpty(actualPrice) && actualPrice.contains("\\.")) {
                binding.tvActualPriceInteger.setText(actualPrice.split("\\.")[0]);
                binding.tvActualPriceDecimal.setText("." + actualPrice.split("\\.")[1]);
            }
        });

    }

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_order_detail;
    }

    @Override
    public int initVariableId() {
        return BR.orderDetailViewModel;
    }

    @Override
    public OrderDetailViewModel initViewModel() {
        OrderRequest lm = new OrderRequest();
        String orderId = getIntent().getStringExtra("orderId");
        return new OrderDetailViewModel(getApplication(), lm, orderId);
    }
}
