package com.xx.hbhconsumer.ui.order;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.Nullable;
import androidx.lifecycle.Observer;

import com.xx.hbhconsumer.BR;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.OrderAdapter;
import com.xx.hbhconsumer.data.http.requst.OrderRequest;
import com.xx.hbhconsumer.data.http.respons.OrderBean;
import com.xx.hbhconsumer.databinding.FragmentOrderListBinding;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseFragment;

public class OrderListFragment extends BaseFragment<FragmentOrderListBinding, OrderListViewModel> {

    public static OrderListFragment newInstance(Integer orderStatus) {
        Bundle args = new Bundle();
        args.putInt("orderStatus", orderStatus);
        OrderListFragment fragment = new OrderListFragment();
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void initData() {

        viewModel.orderList.observe(this, new Observer<List<OrderBean>>() {
            @Override
            public void onChanged(List<OrderBean> orderBeanList) {

                //获取适配器上下文
                OrderAdapter orderListAdapter = new OrderAdapter(getActivity());

                //把adapterset进去
                binding.rvOrderList.setAdapter(orderListAdapter);
                orderListAdapter.mList = orderBeanList;

                orderListAdapter.setOnItemClick((position, data) -> viewModel.goOrderDetail(data.getBusinessId()));

            }
        });

    }

    @Override
    public int viewModelType() {
        return 1;
    }

    @Override
    public int initContentView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return R.layout.fragment_order_list;
    }

    @Override
    public int initVariableId() {
        return BR.orderListViewModel;
    }

    @Override
    public OrderListViewModel initViewModel() {
        OrderRequest model = new OrderRequest();
        Bundle args = getArguments();
        Integer orderStatus = args.getInt("orderStatus");
        String status = "";
        if (orderStatus > 0) {
            status = String.valueOf(orderStatus);
        }
        return new OrderListViewModel(getActivity().getApplication(), model, status);
    }
}
