package com.xx.hbhconsumer.ui.order;

import android.app.Application;
import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.OrderRequest;
import com.xx.hbhconsumer.data.http.respons.OrderBean;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class OrderListViewModel extends BaseViewModel<OrderRequest> {

    private String orderStatus;

    public MutableLiveData<List<OrderBean>> orderList = new  MutableLiveData<>(new ArrayList<>());

    public OrderListViewModel(@NonNull Application application, OrderRequest model, String orderStatus) {
        super(application, model);
        this.orderStatus = orderStatus;
    }
    public void goOrderDetail(String orderId) {
        Bundle bundle = new Bundle();
        bundle.putString("orderId", orderId);
        startActivity(OrderDetailActivity.class, bundle);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        loadData();
    }

    private void loadData() {
        model.getOrderList(orderStatus)
                .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                .doOnSubscribe(OrderListViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<OrderBean>() {
                    @Override
                    public void onSuccess(List<OrderBean> orderBeanList) {
                        orderList.postValue(orderBeanList);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {

                    }


                });
    }
}


