package com.xx.hbhconsumer.ui.recruit;

import android.os.Bundle;

import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.RecruitAdapter;
import com.xx.hbhconsumer.data.http.requst.RecruitRequest;
import com.xx.hbhconsumer.databinding.ActivityRecruitBinding;
import com.xx.hbhconsumer.databinding.ActivityRecruitDetailBinding;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class RecruitDetailActivity extends BaseActivity<ActivityRecruitDetailBinding, RecruitDetailViewModel> {

    @Override
    public void initData() {
        super.initData();

        viewModel.recruitBean.observe(this, recruitBean -> {
            if (recruitBean != null) {
                binding.tvRecruitTitle.setText(recruitBean.getPostName());
                binding.tvRecruitCompany.setText("招聘企业：" + recruitBean.getRecruitmentEnterprise());

                binding.tvAddress.setText(recruitBean.getWorkPlace());

                if ("1".equals(recruitBean.getEducationalRequirement())) {
                    binding.tvEducation.setText("学历：硕士及以上");
                } else if ("2".equals(recruitBean.getEducationalRequirement())) {
                    binding.tvEducation.setText("学历：本科及以上");
                } else if ("3".equals(recruitBean.getEducationalRequirement())) {
                    binding.tvEducation.setText("学历：专科及以上");
                } else if ("4".equals(recruitBean.getEducationalRequirement())) {
                    binding.tvEducation.setText("学历：高中及以上");
                } else if ("5".equals(recruitBean.getEducationalRequirement())) {
                    binding.tvEducation.setText("学历：初中及以上");
                } else if ("6".equals(recruitBean.getEducationalRequirement())) {
                    binding.tvEducation.setText("学历：无");
                }


                if ("1".equals(recruitBean.getWorkExperience())) {
                    binding.tvExperience.setText("经验：1年");
                } else if ("2".equals(recruitBean.getWorkExperience())) {
                    binding.tvExperience.setText("经验：1-3年");
                } else if ("3".equals(recruitBean.getWorkExperience())) {
                    binding.tvExperience.setText("经验：3-5年");
                } else if ("4".equals(recruitBean.getWorkExperience())) {
                    binding.tvExperience.setText("经验：5-7年");
                } else if ("5".equals(recruitBean.getWorkExperience())) {
                    binding.tvExperience.setText("经验：7-10年");
                } else if ("6".equals(recruitBean.getWorkExperience())) {
                    binding.tvExperience.setText("经验：10年以上");
                } else if ("7".equals(recruitBean.getWorkExperience())) {
                    binding.tvExperience.setText("经验：无");
                }

                binding.tvSalary.setText(recruitBean.getPostWage() + "/月");
            }

        });
    }

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_recruit_detail;
    }

    @Override
    public int initVariableId() {
        return BR.couponListViewModel;
    }

    @Override
    public RecruitDetailViewModel initViewModel() {
        RecruitRequest model = new RecruitRequest();
        String id = getIntent().getStringExtra("id");
        return new RecruitDetailViewModel(getApplication(), model, id);
    }
}
