package com.xx.hbhconsumer.ui.recruit;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.PhoneRequest;
import com.xx.hbhconsumer.data.http.requst.RecruitRequest;
import com.xx.hbhconsumer.data.http.respons.RecruitBean;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class RecruitDetailViewModel extends BaseViewModel<RecruitRequest> {

    public MutableLiveData<RecruitBean> recruitBean = new  MutableLiveData<>(null);

    private String id;

    public RecruitDetailViewModel(@NonNull Application application) {
        super(application);
    }

    public RecruitDetailViewModel(@NonNull Application application, RecruitRequest model, String id) {
        super(application, model);
        this.id = id;
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        loadData();
    }

    public void loadData() {
        model.queryAppRecruitmentDetail(id)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(RecruitDetailViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<RecruitBean>() {
                    @Override
                    public void onSuccess(RecruitBean recruitBeans) {
                        recruitBean.postValue(recruitBeans);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                });
    }
}
