package com.xx.hbhconsumer.ui.recruit;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.Nullable;

import com.xx.hbhconsumer.BR;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.NewsAdapter;
import com.xx.hbhconsumer.adapter.RecruitAdapter;
import com.xx.hbhconsumer.data.http.requst.LoginRequest;
import com.xx.hbhconsumer.data.http.requst.RecruitRequest;
import com.xx.hbhconsumer.data.http.respons.OrderBean;
import com.xx.hbhconsumer.databinding.FragmentRecruitListBinding;

import java.util.ArrayList;
import java.util.List;

import me.goldze.mvvmhabit.base.BaseFragment;

public class RecruitListFragment extends BaseFragment<FragmentRecruitListBinding, RecruitListViewModel> {

    public static RecruitListFragment newInstance(Integer recruitType) {
        Bundle args = new Bundle();
        args.putInt("recruitType", recruitType + 1);
        RecruitListFragment fragment = new RecruitListFragment();
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void initData() {

        viewModel.recruitBeanList.observe(this, recruitBeanList -> {
            //获取适配器上下文
            RecruitAdapter orderListAdapter = new RecruitAdapter(getActivity());
            //把adapterset进去
            binding.rvOrderList.setAdapter(orderListAdapter);
            orderListAdapter.mList = recruitBeanList;

            orderListAdapter.setOnItemClick((position, data) -> viewModel.goDetail(data.getBusinessId()));
        });
    }

    @Override
    public int viewModelType() {
        return 1;
    }

    @Override
    public int initContentView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return R.layout.fragment_recruit_list;
    }

    @Override
    public int initVariableId() {
        return BR.recruitViewModel;
    }

    @Override
    public RecruitListViewModel initViewModel() {
        RecruitRequest model = new RecruitRequest();
        Bundle args = getArguments();
        Integer recruitType = args.getInt("recruitType");
        return new RecruitListViewModel(getActivity().getApplication(), model, String.valueOf(recruitType));
    }
}
