package com.xx.hbhconsumer.ui.recruit;

import android.app.Application;
import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.LoginRequest;
import com.xx.hbhconsumer.data.http.requst.RecruitRequest;
import com.xx.hbhconsumer.data.http.respons.AppInformationBean;
import com.xx.hbhconsumer.data.http.respons.RecruitBean;
import com.xx.hbhconsumer.ui.news.NewsListViewModel;
import com.xx.hbhconsumer.ui.order.OrderDetailActivity;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class RecruitListViewModel extends BaseViewModel<RecruitRequest> {

    public MutableLiveData<List<RecruitBean>> recruitBeanList = new  MutableLiveData<>(new ArrayList<>());
    String recruitmentType;

    public RecruitListViewModel(@NonNull Application application, RecruitRequest model, String recruitmentType) {
        super(application, model);
        this.recruitmentType = recruitmentType;
    }

    public void goDetail(String id) {
        Bundle bundle = new Bundle();
        bundle.putString("id", id);
        startActivity(RecruitDetailActivity.class, bundle);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        loadData();
    }

    public void loadData() {
        model.queryAppRecruitmentList(recruitmentType)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(RecruitListViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<RecruitBean>() {
                    @Override
                    public void onSuccess(List<RecruitBean> recruitBeans) {

                        recruitBeanList.postValue(recruitBeans);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {

                    }

                });
    }
}


