package com.xx.hbhconsumer.ui.shop;

import android.os.Bundle;

import androidx.lifecycle.Observer;
import androidx.recyclerview.widget.GridLayoutManager;

import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.ShopDetailGoodsAdapter;
import com.xx.hbhconsumer.data.http.requst.ShopRequest;
import com.xx.hbhconsumer.data.http.respons.ShopGoodsBean;
import com.xx.hbhconsumer.databinding.ActivityShopDetailBinding;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class ShopDetailActivity extends BaseActivity<ActivityShopDetailBinding, ShopDetailViewModel> {

    @Override
    public void initData() {
        super.initData();
        viewModel.shopGoodsBeanList.observe(this, new Observer<List<ShopGoodsBean>>() {
            @Override
            public void onChanged(List<ShopGoodsBean> shopBeanList) {
                //获取适配器上下文
                GridLayoutManager manager = new GridLayoutManager(ShopDetailActivity.this,2);
                binding.rvGoodsList.setLayoutManager(manager);
                //获取适配器上下文
                ShopDetailGoodsAdapter orderListAdapter = new ShopDetailGoodsAdapter(ShopDetailActivity.this);
                //把adapterset进去
                binding.rvGoodsList.setAdapter(orderListAdapter);
                orderListAdapter.mList = shopBeanList;
                orderListAdapter.setOnItemClick((position, data) -> viewModel.goShopGoodsDetail(position));
            }
        });



    }

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_shop_detail;
    }

    @Override
    public int initVariableId() {
        return BR.shopDetailViewModel;
    }

    @Override
    public ShopDetailViewModel initViewModel() {
        ShopRequest lm = new ShopRequest();
        String merchantId = getIntent().getStringExtra("merchantId");
        return new ShopDetailViewModel(getApplication(), lm, merchantId);
    }
}
