package com.xx.hbhconsumer.ui.shop;

import android.os.Bundle;
import android.view.View;

import androidx.lifecycle.Observer;
import androidx.recyclerview.widget.GridLayoutManager;

import com.google.android.flexbox.FlexDirection;
import com.google.android.flexbox.FlexWrap;
import com.google.android.flexbox.FlexboxLayoutManager;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.SearchHistoryAdapter;
import com.xx.hbhconsumer.adapter.ShopDetailGoodsAdapter;
import com.xx.hbhconsumer.data.http.requst.ShopRequest;
import com.xx.hbhconsumer.data.http.respons.OrderBean;
import com.xx.hbhconsumer.data.http.respons.ShopGoodsBean;
import com.xx.hbhconsumer.databinding.ActivityShopSearchBinding;

import java.util.ArrayList;
import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class ShopSearchActivity extends BaseActivity<ActivityShopSearchBinding, ShopSearchViewModel> {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_shop_search;
    }

    @Override
    public int initVariableId() {
        return BR.shopSearchViewModel;
    }

    @Override
    public void initData() {
        super.initData();
        List<OrderBean> orderBeanList = new ArrayList<>();

        FlexboxLayoutManager manager = new FlexboxLayoutManager(this, FlexDirection.ROW, FlexWrap.WRAP);
        binding.rvSearchHistory.setLayoutManager(manager);


        viewModel.searchState.observe(this, new Observer<Integer>() {
            @Override
            public void onChanged(Integer searchState) {
                if (searchState == 0) {
                    binding.rlCategoryBar.setVisibility(View.GONE);
                    binding.rvGoodsList.setVisibility(View.GONE);
                    binding.rlSearchHistoryBar.setVisibility(View.VISIBLE);
                    binding.rvSearchHistory.setVisibility(View.VISIBLE);
                } else {
                    binding.rlCategoryBar.setVisibility(View.VISIBLE);
                    binding.rvGoodsList.setVisibility(View.VISIBLE);
                    binding.rlSearchHistoryBar.setVisibility(View.GONE);
                    binding.rvSearchHistory.setVisibility(View.GONE);
                }
            }
        });

        //获取适配器上下文
        SearchHistoryAdapter searchHistoryAdapter = new SearchHistoryAdapter(this);
        //把adapterset进去
        binding.rvSearchHistory.setAdapter(searchHistoryAdapter);
        searchHistoryAdapter.mList = orderBeanList;

        viewModel.shopGoodsBeanList.observe(this, new Observer<List<ShopGoodsBean>>() {
            @Override
            public void onChanged(List<ShopGoodsBean> shopBeanList) {
                //获取适配器上下文
                GridLayoutManager gridLayoutManager = new GridLayoutManager(ShopSearchActivity.this,2);
                binding.rvGoodsList.setLayoutManager(gridLayoutManager);
                //获取适配器上下文
                ShopDetailGoodsAdapter shopDetailGoodsAdapter = new ShopDetailGoodsAdapter(ShopSearchActivity.this);

                //把adapterset进去
                binding.rvGoodsList.setAdapter(shopDetailGoodsAdapter);
                shopDetailGoodsAdapter.mList = shopBeanList;
                shopDetailGoodsAdapter.setOnItemClick((position, data) -> viewModel.goShopGoodsDetail(position));
            }
        });



    }

    @Override
    public ShopSearchViewModel initViewModel() {
        ShopRequest lm = new ShopRequest();
        String categoryId = getIntent().getStringExtra("categoryId");
        return new ShopSearchViewModel(getApplication(), lm, categoryId);
    }
}
