package com.xx.hbhconsumer.ui.storeservices;

import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.viewpager2.adapter.FragmentStateAdapter;
import androidx.viewpager2.widget.ViewPager2;

import com.google.android.material.tabs.TabLayout;
import com.google.android.material.tabs.TabLayoutMediator;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.databinding.ActivityStoreServicesBinding;
import com.xx.hbhconsumer.ui.order.OrderListFragment;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class StoreServicesActivity extends BaseActivity<ActivityStoreServicesBinding, StoreServicesViewModel> {
    final String[] tabs = new String[]{"会员体系", "服务条款"};
    private TabLayoutMediator mediator;
    TabLayout tabLayout;
    ViewPager2 viewPager2;
    @Override
    public void initData() {
        super.initData();
        // 初始化底部导航栏
        tabLayout = findViewById(R.id.tabLayout);
        viewPager2 = findViewById(R.id.viewPager2);
        tabLayout.setLongClickable(false);
        viewPager2.setOffscreenPageLimit(ViewPager2.OFFSCREEN_PAGE_LIMIT_DEFAULT);
        //Adapter
        viewPager2.setAdapter(new FragmentStateAdapter(getSupportFragmentManager(), getLifecycle()) {
            @NonNull
            @Override
            public Fragment createFragment(int position) {
                //FragmentStateAdapter内部自己会管理已实例化的fragment对象。
                // 所以不需要考虑复用的问题
                return OrderListFragment.newInstance(position);
            }
            @Override
            public int getItemCount() {
                return tabs.length;
            }
        });
        //viewPager 页面切换监听监听

        mediator = new TabLayoutMediator(tabLayout, viewPager2, (tab, position) -> tab.setText(tabs[position]));
        //要执行这一句才是真正将两者绑定起来
        mediator.attach();

    }

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_store_services;
    }

    @Override
    public int initVariableId() {
        return BR.couponListViewModel;
    }

}
